/*******************************************************************
 * 							 Pilot Software
 *
 *		 Copyright(c) 1998, Palm Computing Inc., All Rights Reserved
 *
 *-------------------------------------------------------------------
 * FileName:
 *		Transport.h
 *
 * Description:
 *		Header for routines to stream data.
 *
 * History:
 *   	10/30/98	Newt oday.  Modelled after SerialMgr.h.
 *
 *******************************************************************/

#ifndef __TRANSPORT_H
#define __TRANSPORT_H


// Possible errors returned from Transport provider calls. The code in
//  SerTransport.cpp will translate these into appropriate 
//  SerialMgr error codes
typedef enum
  {
	tptErrNone	= 0,
	tptErrBadParam,
	tptErrBadPort,
	tptErrNoMem,
	tptErrBadConnID,
	tptErrTimeOut,
	tptErrLineErr,
	tptErrAlreadyOpen,
	tptErrStillOpen,
	tptErrNotOpen,
	tptErrNotSupported,
	tptErrInternal
  } TptErrEnum;



// THis define is set by SerLib provider sources so that they don't
// have to include any PalmOS equates in order to get the set of
// shared error codes in TptErrEnum
#ifndef	  SER_TRANSPORT_PLATFORM_IND_ONLY


#ifdef __cplusplus
extern "C" {
#endif

enum { tptSerial, tptPPC, tptSockets };

void	TptSetType			(int type);

Err		TptOpen				(UInt refNum, Word port, DWord baud);
Err		TptClose			(UInt refNum);

ULong	TptSend				(UInt refNum, VoidPtr bufP, ULong count, Err* errP);
Err		TptSendWait			(UInt refNum, Long timeout);
ULong	TptReceive			(UInt refNum, VoidPtr rcvBufP, ULong count, Long timeout, Err* errP);
Err		TptReceiveWait		(UInt refNum, ULong bytes, Long timeout);
void	TptReceiveFlush		(UInt refNum, Long timeout);
Err		TptClearErr			(UInt refNum);

#ifdef __cplusplus
}
#endif


#endif // SER_TRANSPORT_PLATFORM_IND_ONLY

#endif	// __TRANSPORT_H