/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

#ifndef __HOSTPREFERENCES_H__
#define __HOSTPREFERENCES_H__

#include "AppPreferences.h"

// -----------------------------------------------------------------------------
// class HostPreferences
//
// Platform specific sublcass of AppPreferences
// -----------------------------------------------------------------------------

class Preferences : public AppPreferences
{

  public:

    // -----------------------------------------------------------------------------
    // constructor / destructor
    // -----------------------------------------------------------------------------
    
    Preferences( void );
    virtual ~Preferences( void );

    // -----------------------------------------------------------------------------
    // public methods
    // -----------------------------------------------------------------------------

    bool loadFromFile();
    bool storeToFile();

    bool editPreferences();
    bool editDebugging();
    bool editLogging();

    const char* getSkinFile() { return _skinFilePath.c_str(); }

    void statSkinFileList();
    
    // -----------------------------------------------------------------------------
    // public data members
    // -----------------------------------------------------------------------------
    ParamList fSkinFiles;

  private:
    
    // -----------------------------------------------------------------------------
    // friends
    // -----------------------------------------------------------------------------

    friend class Fl_Window* makePrefsWindow( Preferences& prefs );
    friend class Fl_Window* makeDebugWindow( Preferences& prefs );
    friend void updateCheckButtons( Fl_Window* w, Preferences& prefs, int panel );
    friend void updatePreferences( Fl_Window* w, Preferences& prefs, int panel );

    // -----------------------------------------------------------------------------
    // private data members
    // -----------------------------------------------------------------------------
    
    string _serialDevice;
    string _skinFilePath;
};

extern Preferences* gHostPrefs;

const char BASE_SKIN_NAME[] = "Normal (built-in)";

#endif /* __HOSTPREFERENCES_H__ */
