/* ================================================================================== */
/* Copyright (c) 1998-1999 3Com Corporation or its subsidiaries. All rights reserved. */
/* ================================================================================== */

//	1000 - 1999: Message Templates
//		1000 - 1199:	Error messages
//		1200 - 1399:	Other messages
//	2000 - 2999: Template Parts
//		2000 - 2199:	Misc parts
//		2200 - 2399:	Operations descriptions
//		2400 - 2599:	Error descriptions
//			2400 - 2499:	OS Errors (e.g., "the file was not found")
//			2500 - 2599:	User/app errors (e.g., "I don't understand that file")
//		2600 - 2799:	Recovery strings (e.g., "Reboot and try again")
//		2900 - 2964:	Exception descriptions (e.g., "bus error")
//		3000 - 4999:	Palm OS system function names
//		5000 - 6999:	Palm OS Library function names
//		7000 - xxxx:	Palm OS Error descriptions

#include "Strings.r.h"	// kStr_ values


int _ResStrIndex[6000];
char* _ResStrTable[] = {

// --------------------------------------------------------------------------------
//	Message Templates -- Error messages
// --------------------------------------------------------------------------------

	"Could not %operation because %reason.",

	"Could not %operation because %reason.  %recovery.",


	"""%Application"" %version has just %operation the CPU registers.\n\nThis technique is not permitted for Palm OS applications and may not work in future Palm products which have hardware changes.  ""%Application"" will likely crash this or future Palm devices.  When run on a real Palm device, a soft reset with a paper clip will usually restore the Palm device without data loss although a hard reset and full data loss are known to happen.\n\nUsers should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation low memory.\n\nThis technique is not permitted for Palm OS applications and may not work in future Palm products which have hardware changes.  ""%Application"" will likely crash this or future Palm devices.  When run on a real Palm device, a soft reset with a paper clip will usually restore the Palm device without data loss although a hard reset and full data loss are known to happen.\n\nUsers should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation Palm OS global variables.\n\nThis technique may not work in future Palm OS versions. Palm OS provides supported calls which will generally achieve the same result and work in future Palm OS versions.  Because ""%application"" bypasses this support, it will likely crash future Palm OS versions.  When run on a real Palm device, a soft reset with a paper clip will usually restore the Palm device without data loss although a hard reset and full data loss is possible.\n\nUsers should expect to upgrade this product for future Palm OS versions.",

	"""%Application"" %version has just %operation screen memory.\n\nThis technique may not work in future Palm products which have hardware changes.  Palm OS provides supported calls which will both achieve the same result and work in future hardware.  Because ""%application"" bypasses this support, it will likely crash future Palm devices.  When run on a real Palm device, a soft reset with a paper clip will restore the device and no data loss should occur.\n\nUsers should expect to upgrade this product for future Palm devices.",

	"""%Application"" %version has just %operation memory manager data structures.\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation an unlocked memory chunk.\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation a section of memory known as the ""stack"".\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation an uninitialized section of memory known as the ""stack"".\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation an unallocated chunk of memory.\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just %operation an uninitialized chunk of memory known.\n\nThis problem indicates an error in the application.  Users should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version just tried to write to the storage heap and that's just plain not allowed!  Try using DmWrite.",

	"""%Application"" %version tried to call Palm OS routine #%trapNum (%trapName). This routine does not exist in this version of the Palm OS.\n\nThis problem indicates an error in the application.  If this is the latest version of ""%application"", please report this to the application author.",

	"""%Application"" %version has just tried to access a global variable at a time when global variable access is not allowed.  Typically, this means that the application tried to access the global variable after PilotMain was called with a launch code other than 'sysAppLaunchCmdNormalLaunch'.  The last launch code observed by the emulator was '%launchCode'.",

	"""%Application"" %version has just %operation memory location zero (NULL).\n\nThis technique is not permitted for Palm OS applications and may not work in future Palm products which have hardware changes.  ""%Application"" will likely crash this or future Palm devices.  When run on a real Palm device, a soft reset with a paper clip will usually restore the Palm device without data loss although a hard reset and full data loss are known to happen.\n\nUsers should upgrade this product immediately to safeguard their data.",

	"""%Application"" %version has just tried to perform a floating point operation using a calling sequence particular to the Mac OS.  This indicates that the application was compiled with the incorrect Floating Point option in the development environment used to create it.  If this is the latest version of ""%application"", please report this to the application author.",


	"""%Application"" %version reports ""%message"".  If this is the latest version of ""%application"", please report this to the application author.",

	"""%Application"" %version has just performed an illegal operation.  It performed a ""%operation"".  If this is the latest version of ""%application"", please report this to the application author.",

	"During a regular checkup, Poser determined that the dynamic heap chunk with header address %header_address got corrupted. %corruption_type.",

	"The application is getting close to overflowing the stack.",

	"The application has just overflowed the stack.",

	"The Memory Manager semaphore has been held for longer than 1 minute. It is recommended that applications not hold the semaphore any longer than that.",

	"Form object ID #%objID (left=%left, top=%top, right=%right, bottom=%bottom) from ""%application"" %version has a height or width of zero.  It is recommended that applications hide objects by calling FrmHideObject instead of setting their dimensions to zero.",

	"Form object ID #%objID (left=%left, top=%top, right=%right, bottom=%bottom) from ""%application"" %version is completely offscreen.  It is recommended that applications hide objects by calling FrmHideObject instead of placing them completely offscreen.",

	"The ROM you've chosen has an invalid checksum.\n\nThe most common reason for an invalid checksum has been from the use of utility programs that modify the contents of the ROM without also updating its internal checksum.\n\nPalm Computing does not support the use of this ROM.  Use it with caution.",


// --------------------------------------------------------------------------------
//	Message Templates -- Other messages
// --------------------------------------------------------------------------------

	"%application %version",

	"%d of %d files",

	"Gremlin #%ld",

	"Event %s of %s",

	"Event %s",

	"Elapsed Time: %s",

	"Gremlin #%d started, %ld steps.\n",

	"Gremlin #%d stopped at event %ld of %ld after %ld milliseconds.\n",

	"Save screen as:",

	"Entire Palm OS device",

	"%s, Line: %d, %s",

	"Unknown fatal error occured!",

	"The emulator is not ready to %s at this time.\n(Perhaps it is turned off?)",

	"Save changes to the %AppName document ""%DocName"" before closing?",

	"Save changes to the %AppName document ""%DocName"" before quitting?",

	"===========================================================\nThis file contains only the last %ldK of generated text.\n===========================================================\n\n",


// --------------------------------------------------------------------------------
//	Template Parts -- Misc parts
// --------------------------------------------------------------------------------

	"Palm OS(TM) Emulator",

	"untitled",

	"Palm.ROM",

	"Profile Results",

	"Autoload",

	"Autorun",

	"AutorunAndQuit",

	"read directly from",

	"written directly to",


	"The current application",

	"the current application",

	"(unknown version)",


	"OK",

	"Cancel",

	"Yes",

	"No",

	"Continue",

	"Debug",

	"Reset",


	"Browse",


	"partial",

	"functions",

	"interrupts",

	"overflow",

	"interrupt $%02lX",

	"%s  $%04lX.t",

	"%s  $%08lX.m",

	"  $%08lX.d",

	"unknown  $%08lX",


	"unknown trap number",

	"unknown error code",


	"None",


	"The chunk was not within the heap it was supposed to be",

	"The size of the chunk (%chunk_size) was larger than the currently accepted maximum (%chunk_max)",

	"Some unused flags were set to ""1""",

	"The ""hOffset"" field of the chunk header did not reference a memory location within a master pointer block",

	"The master pointer referenced by the ""hOffset"" field in the chunk header didn't point back to the chunk",

	"The lock count for a fixed block was not 15",


// --------------------------------------------------------------------------------
//	Template Parts -- Operations descriptions
// --------------------------------------------------------------------------------

	"complete the operation",


	"show the About box",


	"create a new session",

	"open the file ""%filename""",

	"close the window",

	"save the file ""%filename""",

	"save the screen",

	"install the Palm OS file ""%filename""",

	"install the Palm OS files",

	"start the HotSync",

	"reset the device",

	"transfer the ROM",

	"quit the application",


	"open the Preferences dialog box",

	"open the Logging Options dialog box",

	"open the Debug Options dialog box",

	"open the Breakpoints dialog box",


	"start the gremlin",

	"step the gremlin",

	"resume the gremlin",

	"stop the gremlin",


#if HAS_PROFILING
	"start profiling",

	"stop profiling",

	"dump the profiling results",

#endif


	"resize the window",

	"enter the key",

	"enter the pen stroke",

	"press the hardware button",

	"open the selected files",

	"load the application preferences",

	"open the serial port",



// --------------------------------------------------------------------------------
//	Template Parts -- Error descriptions -- OS Errors
// --------------------------------------------------------------------------------

	"error %error occurred",

	"the user cancelled",

	"the operation timed out",


// Disk errors
	"the directory is full",

	"the disk is full",

	"the disk is not present",

	"of a random I/O error",

	"the file name is badly formed",

	"too many files are open",

	"the file wasn't found",

	"the disk is write protected",

	"the file is locked",

	"the disk is locked",

	"it is being used by another application",

	"a file with that name already exists",


// Memory errors
	"the application ran out of memory",


// Communications errors
	"it is being used by another application",


// PPC Toolbox errors

// Apple event errors

// Palm OS Errors

	"Palm OS error %error (%error_desc) occurred",

	"the database is currently open",

	"the device is out of memory",



// --------------------------------------------------------------------------------
//	Template Parts -- Error descriptions -- User/app errors
// --------------------------------------------------------------------------------

	"you can only drag files of the same type onto the Emulator window",

	"you can only drag one Palm Session File onto the Emulator window at a time",

	"you can only drag one Palm ROM File onto the Emulator window at a time",

	"the Emulator doesn't support the file you just dragged onto its window",


// PSF file errors
	"the file appears to be in an old format",

	"the chosen ROM file cannot be used with the specified hardware device",


// ROM file errors
	"it doesn't appear to be a valid ROM file",

	"this Debug 2.0 ROM is not supported",



// --------------------------------------------------------------------------------
//	Template Parts -- Recovery strings
// --------------------------------------------------------------------------------

	"Delete some files and try again, or try saving to a different disk",

	"Unlock the disk and try again",

	"Unlock the file and try again",


	"Please give the application more memory",


	"To download the ROM from your Palm device, choose ""Transfer ROM..."" from the File menu",

	"Please download the latest from http://www.palm.com",



// --------------------------------------------------------------------------------
//	Template Parts -- Exception descriptions
// --------------------------------------------------------------------------------

	"<Nothing>",

	"<Nothing>",

	"bus error",

	"address error",

	"illegal instruction",

	"divide by zero",

	"CHK instruction",

	"TRAP instruction",

	"privilege violation",

	"trace",

	"line 1010 instruction",

	"line 1111 instruction",

	"reserved - 12",

	"coprocessor error",

	"format error",

	"uninitialized interrupt",

	"reserved - 0",

	"reserved - 1",

	"reserved - 2",

	"reserved - 3",

	"reserved - 4",

	"reserved - 5",

	"reserved - 6",

	"reserved - 7",

	"spurious interrupt",

	"interrupt - 1",

	"interrupt - 2",

	"interrupt - 3",

	"interrupt - 4",

	"interrupt - 5",

	"interrupt - 6",

	"interrupt - 7",

	"TRAP $0",

	"TRAP $1",

	"TRAP $2",

	"TRAP $3",

	"TRAP $4",

	"TRAP $5",

	"TRAP $6",

	"TRAP $7",

	"TRAP $8",

	"TRAP $9",

	"TRAP $A",

	"TRAP $B",

	"TRAP $C",

	"TRAP $D",

	"TRAP $E",

	"TRAP $F",

	"unassigned - 0",

	"unassigned - 1",

	"unassigned - 2",

	"unassigned - 3",

	"unassigned - 4",

	"unassigned - 5",

	"unassigned - 6",

	"unassigned - 7",

	"unassigned - 8",

	"unassigned - 9",

	"unassigned - 10",

	"unassigned - 11",

	"unassigned - 12",

	"unassigned - 13",

	"unassigned - 14",

	"unassigned - 15",


// --------------------------------------------------------------------------------
//	Template Parts -- System function names
// --------------------------------------------------------------------------------

/*
	The following strings were generated with the following MPW script:

		#######################################################################
		# Setup Variables
		#######################################################################
		set TrapNum 1
		set Space '[ t]+'

		Set PilotDir "Phantom:Projects:Palm:Viewer:main:"
		Set SysTraps "{PilotDir}Incs:System:SysTraps.h"
		set Dest "Phantom:SystemTrapNames"

		#######################################################################
		# Copy the System Header File to a temporary file
		#######################################################################
		duplicate -y -d "{PilotDir}Incs:System:SysTraps.h" "{Dest}"
		setfile -a l "{Dest}"
		open "{Dest}"
		Target "{Dest}"

		#######################################################################
		# Delete everything except the trap table enumerated type
		#######################################################################
		replace  :/typedef enum[ t]+{/ ""
		replace /sysTrapLastTrapNumber/: ""

		#######################################################################
		# Get rid of the first value
		#######################################################################
		find 
		replace /{Space}={Space}sysTrapBase/ ""

		#######################################################################
		# Get rid of Comments
		#######################################################################
		find 
		replace -c  //// ""

		#######################################################################
		# Go through and replace each line with a debugger script command
		#######################################################################
		Set Exit 0
		Set TrapNum 0
		Find 
		Loop
			replace /sysTrap([a-zA-Z0-9]+)1,Ű/  "ID=kStr_SysTrapBase+{TrapNum}nENGLISH=1n"
			Break If {Status} != 0
			Set TrapNum `Evaluate {TrapNum}+1`
		End

		#######################################################################
		# Strip trailing spaces.  Collapse multiple blank lines.
		#######################################################################
		Find 
		Replace -c  /[tf ]+/ ""

		Find 
		Replace -c  /n[n]+/ "nn"

		Close -y "{Dest}"
*/

	"MemInit",

	"MemInitHeapTable",

	"MemStoreInit",

	"MemCardFormat",

	"MemCardInfo",

	"MemStoreInfo",

	"MemStoreSetInfo",

	"MemNumHeaps",

	"MemNumRAMHeaps",

	"MemHeapID",

	"MemHeapPtr",

	"MemHeapFreeBytes",

	"MemHeapSize",

	"MemHeapFlags",

	"MemHeapCompact",

	"MemHeapInit",

	"MemHeapFreeByOwnerID",

	"MemChunkNew",

	"MemChunkFree",

	"MemPtrNew",

	"MemPtrRecoverHandle",

	"MemPtrFlags",

	"MemPtrSize",

	"MemPtrOwner",

	"MemPtrHeapID",

	"MemPtrCardNo",

	"MemPtrToLocalID",

	"MemPtrSetOwner",

	"MemPtrResize",

	"MemPtrResetLock",

	"MemHandleNew",

	"MemHandleLockCount",

	"MemHandleToLocalID",

	"MemHandleLock",

	"MemHandleUnlock",

	"MemLocalIDToGlobal",

	"MemLocalIDKind",

	"MemLocalIDToPtr",

	"MemMove",

	"MemSet",

	"MemStoreSearch",

	"Reserved6",

	"MemKernelInit",

	"MemHandleFree",

	"MemHandleFlags",

	"MemHandleSize",

	"MemHandleOwner",

	"MemHandleHeapID",

	"MemHandleDataStorage",

	"MemHandleCardNo",

	"MemHandleSetOwner",

	"MemHandleResize",

	"MemHandleResetLock",

	"MemPtrUnlock",

	"MemLocalIDToLockedPtr",

	"MemSetDebugMode",

	"MemHeapScramble",

	"MemHeapCheck",

	"MemNumCards",

	"MemDebugMode",

	"MemSemaphoreReserve",

	"MemSemaphoreRelease",

	"MemHeapDynamic",

	"MemNVParams",

	"DmInit",

	"DmCreateDatabase",

	"DmDeleteDatabase",

	"DmNumDatabases",

	"DmGetDatabase",

	"DmFindDatabase",

	"DmDatabaseInfo",

	"DmSetDatabaseInfo",

	"DmDatabaseSize",

	"DmOpenDatabase",

	"DmCloseDatabase",

	"DmNextOpenDatabase",

	"DmOpenDatabaseInfo",

	"DmResetRecordStates",

	"DmGetLastErr",

	"DmNumRecords",

	"DmRecordInfo",

	"DmSetRecordInfo",

	"DmAttachRecord",

	"DmDetachRecord",

	"DmMoveRecord",

	"DmNewRecord",

	"DmRemoveRecord",

	"DmDeleteRecord",

	"DmArchiveRecord",

	"DmNewHandle",

	"DmRemoveSecretRecords",

	"DmQueryRecord",

	"DmGetRecord",

	"DmResizeRecord",

	"DmReleaseRecord",

	"DmGetResource",

	"DmGet1Resource",

	"DmReleaseResource",

	"DmResizeResource",

	"DmNextOpenResDatabase",

	"DmFindResourceType",

	"DmFindResource",

	"DmSearchResource",

	"DmNumResources",

	"DmResourceInfo",

	"DmSetResourceInfo",

	"DmAttachResource",

	"DmDetachResource",

	"DmNewResource",

	"DmRemoveResource",

	"DmGetResourceIndex",

	"DmQuickSort",

	"DmQueryNextInCategory",

	"DmNumRecordsInCategory",

	"DmPositionInCategory",

	"DmSeekRecordInCategory",

	"DmMoveCategory",

	"DmOpenDatabaseByTypeCreator",

	"DmWrite",

	"DmStrCopy",

	"DmGetNextDatabaseByTypeCreator",

	"DmWriteCheck",

	"DmMoveOpenDBContext",

	"DmFindRecordByID",

	"DmGetAppInfoID",

	"DmFindSortPositionV10",

	"DmSet",

	"DmCreateDatabaseFromImage",

	"DbgSrcMessage",

	"DbgMessage",

	"DbgGetMessage",

	"DbgCommSettings",

	"ErrDisplayFileLineMsg",

	"ErrSetJump",

	"ErrLongJump",

	"ErrThrow",

	"ErrExceptionList",

	"SysBroadcastActionCode",

	"SysUnimplemented",

	"SysColdBoot",

	"SysReset",

	"SysDoze",

	"SysAppLaunch",

	"SysAppStartup",

	"SysAppExit",

	"SysSetA5",

	"SysSetTrapAddress",

	"SysGetTrapAddress",

	"SysTranslateKernelErr",

	"SysSemaphoreCreate",

	"SysSemaphoreDelete",

	"SysSemaphoreWait",

	"SysSemaphoreSignal",

	"SysTimerCreate",

	"SysTimerWrite",

	"SysTaskCreate",

	"SysTaskDelete",

	"SysTaskTrigger",

	"SysTaskID",

	"SysTaskUserInfoPtr",

	"SysTaskDelay",

	"SysTaskSetTermProc",

	"SysUILaunch",

	"SysNewOwnerID",

	"SysSemaphoreSet",

	"SysDisableInts",

	"SysRestoreStatus",

	"SysUIAppSwitch",

	"SysCurAppInfoPV20",

	"SysHandleEvent",

	"SysInit",

	"SysQSort",

	"SysCurAppDatabase",

	"SysFatalAlert",

	"SysResSemaphoreCreate",

	"SysResSemaphoreDelete",

	"SysResSemaphoreReserve",

	"SysResSemaphoreRelease",

	"SysSleep",

	"SysKeyboardDialogV10",

	"SysAppLauncherDialog",

	"SysSetPerformance",

	"SysBatteryInfoV20",

	"SysLibInstall",

	"SysLibRemove",

	"SysLibTblEntry",

	"SysLibFind",

	"SysBatteryDialog",

	"SysCopyStringResource",

	"SysKernelInfo",

	"SysLaunchConsole",

	"SysTimerDelete",

	"SysSetAutoOffTime",

	"SysFormPointerArrayToStrings",

	"SysRandom",

	"SysTaskSwitching",

	"SysTimerRead",

	"StrCopy",

	"StrCat",

	"StrLen",

	"StrCompare",

	"StrIToA",

	"StrCaselessCompare",

	"StrIToH",

	"StrChr",

	"StrStr",

	"StrAToI",

	"StrToLower",

	"SerReceiveISP",

	"SlkOpen",

	"SlkClose",

	"SlkOpenSocket",

	"SlkCloseSocket",

	"SlkSocketRefNum",

	"SlkSocketSetTimeout",

	"SlkFlushSocket",

	"SlkSetSocketListener",

	"SlkSendPacket",

	"SlkReceivePacket",

	"SlkSysPktDefaultResponse",

	"SlkProcessRPC",

	"ConPutS",

	"ConGetS",

	"FplInit",

	"FplFree",

	"FplFToA",

	"FplAToF",

	"FplBase10Info",

	"FplLongToFloat",

	"FplFloatToLong",

	"FplFloatToULong",

	"FplMul",

	"FplAdd",

	"FplSub",

	"FplDiv",

	"ScrInit",

	"ScrCopyRectangle",

	"ScrDrawChars",

	"ScrLineRoutine",

	"ScrRectangleRoutine",

	"ScrScreenInfo",

	"ScrDrawNotify",

	"ScrSendUpdateArea",

	"ScrCompressScanLine",

	"ScrDeCompressScanLine",

	"TimGetSeconds",

	"TimSetSeconds",

	"TimGetTicks",

	"TimInit",

	"TimSetAlarm",

	"TimGetAlarm",

	"TimHandleInterrupt",

	"TimSecondsToDateTime",

	"TimDateTimeToSeconds",

	"TimAdjust",

	"TimSleep",

	"TimWake",

	"CategoryCreateListV10",

	"CategoryFreeListV10",

	"CategoryFind",

	"CategoryGetName",

	"CategoryEditV10",

	"CategorySelectV10",

	"CategoryGetNext",

	"CategorySetTriggerLabel",

	"CategoryTruncateName",

	"ClipboardAddItem",

	"ClipboardCheckIfItemExist",

	"ClipboardGetItem",

	"CtlDrawControl",

	"CtlEraseControl",

	"CtlHideControl",

	"CtlShowControl",

	"CtlGetValue",

	"CtlSetValue",

	"CtlGetLabel",

	"CtlSetLabel",

	"CtlHandleEvent",

	"CtlHitControl",

	"CtlSetEnabled",

	"CtlSetUsable",

	"CtlEnabled",

	"EvtInitialize",

	"EvtAddEventToQueue",

	"EvtCopyEvent",

	"EvtGetEvent",

	"EvtGetPen",

	"EvtSysInit",

	"EvtGetSysEvent",

	"EvtProcessSoftKeyStroke",

	"EvtGetPenBtnList",

	"EvtSetPenQueuePtr",

	"EvtPenQueueSize",

	"EvtFlushPenQueue",

	"EvtEnqueuePenPoint",

	"EvtDequeuePenStrokeInfo",

	"EvtDequeuePenPoint",

	"EvtFlushNextPenStroke",

	"EvtSetKeyQueuePtr",

	"EvtKeyQueueSize",

	"EvtFlushKeyQueue",

	"EvtEnqueueKey",

	"EvtDequeueKeyEvent",

	"EvtWakeup",

	"EvtResetAutoOffTimer",

	"EvtKeyQueueEmpty",

	"EvtEnableGraffiti",

	"FldCopy",

	"FldCut",

	"FldDrawField",

	"FldEraseField",

	"FldFreeMemory",

	"FldGetBounds",

	"FldGetTextPtr",

	"FldGetSelection",

	"FldHandleEvent",

	"FldPaste",

	"FldRecalculateField",

	"FldSetBounds",

	"FldSetText",

	"FldGetFont",

	"FldSetFont",

	"FldSetSelection",

	"FldGrabFocus",

	"FldReleaseFocus",

	"FldGetInsPtPosition",

	"FldSetInsPtPosition",

	"FldSetScrollPosition",

	"FldGetScrollPosition",

	"FldGetTextHeight",

	"FldGetTextAllocatedSize",

	"FldGetTextLength",

	"FldScrollField",

	"FldScrollable",

	"FldGetVisibleLines",

	"FldGetAttributes",

	"FldSetAttributes",

	"FldSendChangeNotification",

	"FldCalcFieldHeight",

	"FldGetTextHandle",

	"FldCompactText",

	"FldDirty",

	"FldWordWrap",

	"FldSetTextAllocatedSize",

	"FldSetTextHandle",

	"FldSetTextPtr",

	"FldGetMaxChars",

	"FldSetMaxChars",

	"FldSetUsable",

	"FldInsert",

	"FldDelete",

	"FldUndo",

	"FldSetDirty",

	"FldSendHeightChangeNotification",

	"FldMakeFullyVisible",

	"FntGetFont",

	"FntSetFont",

	"FntGetFontPtr",

	"FntBaseLine",

	"FntCharHeight",

	"FntLineHeight",

	"FntAverageCharWidth",

	"FntCharWidth",

	"FntCharsWidth",

	"FntDescenderHeight",

	"FntCharsInWidth",

	"FntLineWidth",

	"FrmInitForm",

	"FrmDeleteForm",

	"FrmDrawForm",

	"FrmEraseForm",

	"FrmGetActiveForm",

	"FrmSetActiveForm",

	"FrmGetActiveFormID",

	"FrmGetUserModifiedState",

	"FrmSetNotUserModified",

	"FrmGetFocus",

	"FrmSetFocus",

	"FrmHandleEvent",

	"FrmGetFormBounds",

	"FrmGetWindowHandle",

	"FrmGetFormId",

	"FrmGetFormPtr",

	"FrmGetNumberOfObjects",

	"FrmGetObjectIndex",

	"FrmGetObjectId",

	"FrmGetObjectType",

	"FrmGetObjectPtr",

	"FrmHideObject",

	"FrmShowObject",

	"FrmGetObjectPosition",

	"FrmSetObjectPosition",

	"FrmGetControlValue",

	"FrmSetControlValue",

	"FrmGetControlGroupSelection",

	"FrmSetControlGroupSelection",

	"FrmCopyLabel",

	"FrmSetLabel",

	"FrmGetLabel",

	"FrmSetCategoryLabel",

	"FrmGetTitle",

	"FrmSetTitle",

	"FrmAlert",

	"FrmDoDialog",

	"FrmCustomAlert",

	"FrmHelp",

	"FrmUpdateScrollers",

	"FrmGetFirstForm",

	"FrmVisible",

	"FrmGetObjectBounds",

	"FrmCopyTitle",

	"FrmGotoForm",

	"FrmPopupForm",

	"FrmUpdateForm",

	"FrmReturnToForm",

	"FrmSetEventHandler",

	"FrmDispatchEvent",

	"FrmCloseAllForms",

	"FrmSaveAllForms",

	"FrmGetGadgetData",

	"FrmSetGadgetData",

	"FrmSetCategoryTrigger",

	"UIInitialize",

	"UIReset",

	"InsPtInitialize",

	"InsPtSetLocation",

	"InsPtGetLocation",

	"InsPtEnable",

	"InsPtEnabled",

	"InsPtSetHeight",

	"InsPtGetHeight",

	"InsPtCheckBlink",

	"LstSetDrawFunction",

	"LstDrawList",

	"LstEraseList",

	"LstGetSelection",

	"LstGetSelectionText",

	"LstHandleEvent",

	"LstSetHeight",

	"LstSetSelection",

	"LstSetListChoices",

	"LstMakeItemVisible",

	"LstGetNumberOfItems",

	"LstPopupList",

	"LstSetPosition",

	"MenuInit",

	"MenuDispose",

	"MenuHandleEvent",

	"MenuDrawMenu",

	"MenuEraseStatus",

	"MenuGetActiveMenu",

	"MenuSetActiveMenu",

	"RctSetRectangle",

	"RctCopyRectangle",

	"RctInsetRectangle",

	"RctOffsetRectangle",

	"RctPtInRectangle",

	"RctGetIntersection",

	"TblDrawTable",

	"TblEraseTable",

	"TblHandleEvent",

	"TblGetItemBounds",

	"TblSelectItem",

	"TblGetItemInt",

	"TblSetItemInt",

	"TblSetItemStyle",

	"TblUnhighlightSelection",

	"TblSetRowUsable",

	"TblGetNumberOfRows",

	"TblSetCustomDrawProcedure",

	"TblSetRowSelectable",

	"TblRowSelectable",

	"TblSetLoadDataProcedure",

	"TblSetSaveDataProcedure",

	"TblGetBounds",

	"TblSetRowHeight",

	"TblGetColumnWidth",

	"TblGetRowID",

	"TblSetRowID",

	"TblMarkRowInvalid",

	"TblMarkTableInvalid",

	"TblGetSelection",

	"TblInsertRow",

	"TblRemoveRow",

	"TblRowInvalid",

	"TblRedrawTable",

	"TblRowUsable",

	"TblReleaseFocus",

	"TblEditing",

	"TblGetCurrentField",

	"TblSetColumnUsable",

	"TblGetRowHeight",

	"TblSetColumnWidth",

	"TblGrabFocus",

	"TblSetItemPtr",

	"TblFindRowID",

	"TblGetLastUsableRow",

	"TblGetColumnSpacing",

	"TblFindRowData",

	"TblGetRowData",

	"TblSetRowData",

	"TblSetColumnSpacing",

	"WinCreateWindow",

	"WinCreateOffscreenWindow",

	"WinDeleteWindow",

	"WinInitializeWindow",

	"WinAddWindow",

	"WinRemoveWindow",

	"WinSetActiveWindow",

	"WinSetDrawWindow",

	"WinGetDrawWindow",

	"WinGetActiveWindow",

	"WinGetDisplayWindow",

	"WinGetFirstWindow",

	"WinEnableWindow",

	"WinDisableWindow",

	"WinGetWindowFrameRect",

	"WinDrawWindowFrame",

	"WinEraseWindow",

	"WinSaveBits",

	"WinRestoreBits",

	"WinCopyRectangle",

	"WinScrollRectangle",

	"WinGetDisplayExtent",

	"WinGetWindowExtent",

	"WinDisplayToWindowPt",

	"WinWindowToDisplayPt",

	"WinGetClip",

	"WinSetClip",

	"WinResetClip",

	"WinClipRectangle",

	"WinDrawLine",

	"WinDrawGrayLine",

	"WinEraseLine",

	"WinInvertLine",

	"WinFillLine",

	"WinDrawRectangle",

	"WinEraseRectangle",

	"WinInvertRectangle",

	"WinDrawRectangleFrame",

	"WinDrawGrayRectangleFrame",

	"WinEraseRectangleFrame",

	"WinInvertRectangleFrame",

	"WinGetFramesRectangle",

	"WinDrawChars",

	"WinEraseChars",

	"WinInvertChars",

	"WinGetPattern",

	"WinSetPattern",

	"WinSetUnderlineMode",

	"WinDrawBitmap",

	"WinModal",

	"WinGetWindowBounds",

	"WinFillRectangle",

	"WinDrawInvertedChars",

	"PrefOpenPreferenceDBV10",

	"PrefGetPreferences",

	"PrefSetPreferences",

	"PrefGetAppPreferencesV10",

	"PrefSetAppPreferencesV10",

	"SndInit",

	"SndSetDefaultVolume",

	"SndGetDefaultVolume",

	"SndDoCmd",

	"SndPlaySystemSound",

	"AlmInit",

	"AlmCancelAll",

	"AlmAlarmCallback",

	"AlmSetAlarm",

	"AlmGetAlarm",

	"AlmDisplayAlarm",

	"AlmEnableNotification",

	"HwrGetRAMMapping",

	"HwrMemWritable",

	"HwrMemReadable",

	"HwrDoze",

	"HwrSleep",

	"HwrWake",

	"HwrSetSystemClock",

	"HwrSetCPUDutyCycle",

	"HwrLCDInit",

	"HwrLCDSleep",

	"HwrTimerInit",

	"HwrCursor",

	"HwrBatteryLevel",

	"HwrDelay",

	"HwrEnableDataWrites",

	"HwrDisableDataWrites",

	"HwrLCDBaseAddr",

	"HwrLCDDrawBitmap",

	"HwrTimerSleep",

	"HwrTimerWake",

	"HwrLCDWake",

	"HwrIRQ1Handler",

	"HwrIRQ2Handler",

	"HwrIRQ3Handler",

	"HwrIRQ4Handler",

	"HwrIRQ5Handler",

	"HwrIRQ6Handler",

	"HwrDockSignals",

	"HwrPluggedIn",

	"Crc16CalcBlock",

	"SelectDayV10",

	"SelectTime",

	"DayDrawDaySelector",

	"DayHandleEvent",

	"DayDrawDays",

	"DayOfWeek",

	"DaysInMonth",

	"DayOfMonth",

	"DateDaysToDate",

	"DateToDays",

	"DateAdjust",

	"DateSecondsToDate",

	"DateToAscii",

	"DateToDOWDMFormat",

	"TimeToAscii",

	"Find",

	"FindStrInStr",

	"FindSaveMatch",

	"FindGetLineBounds",

	"FindDrawHeader",

	"PenOpen",

	"PenClose",

	"PenGetRawPen",

	"PenCalibrate",

	"PenRawToScreen",

	"PenScreenToRaw",

	"PenResetCalibration",

	"PenSleep",

	"PenWake",

	"ResLoadForm",

	"ResLoadMenu",

	"FtrInit",

	"FtrUnregister",

	"FtrGet",

	"FtrSet",

	"FtrGetByIndex",

	"GrfInit",

	"GrfFree",

	"GrfGetState",

	"GrfSetState",

	"GrfFlushPoints",

	"GrfAddPoint",

	"GrfInitState",

	"GrfCleanState",

	"GrfMatch",

	"GrfGetMacro",

	"GrfFilterPoints",

	"GrfGetNumPoints",

	"GrfGetPoint",

	"GrfFindBranch",

	"GrfMatchGlyph",

	"GrfGetGlyphMapping",

	"GrfGetMacroName",

	"GrfDeleteMacro",

	"GrfAddMacro",

	"GrfGetAndExpandMacro",

	"GrfProcessStroke",

	"GrfFieldChange",

	"GetCharSortValue",

	"GetCharAttr",

	"GetCharCaselessValue",

	"PwdExists",

	"PwdVerify",

	"PwdSet",

	"PwdRemove",

	"GsiInitialize",

	"GsiSetLocation",

	"GsiEnable",

	"GsiEnabled",

	"GsiSetShiftState",

	"KeyInit",

	"KeyHandleInterrupt",

	"KeyCurrentState",

	"KeyResetDoubleTap",

	"KeyRates",

	"KeySleep",

	"KeyWake",

	"DlkControl",

	"DlkStartServer",

	"DlkGetSyncInfo",

	"DlkSetLogEntry",

	"IntlDispatch",

	"SysLibLoad",

	"SndPlaySmf",

	"SndCreateMidiList",

	"AbtShowAbout",

	"MdmDial",

	"MdmHangUp",

	"DmSearchRecord",

	"SysInsertionSort",

	"DmInsertionSort",

	"LstSetTopItem",

	"SclSetScrollBar",

	"SclDrawScrollBar",

	"SclHandleEvent",

	"SysMailboxCreate",

	"SysMailboxDelete",

	"SysMailboxFlush",

	"SysMailboxSend",

	"SysMailboxWait",

	"SysTaskWait",

	"SysTaskWake",

	"SysTaskWaitClr",

	"SysTaskSuspend",

	"SysTaskResume",

	"CategoryCreateList",

	"CategoryFreeList",

	"CategoryEditV20",

	"CategorySelect",

	"DmDeleteCategory",

	"SysEvGroupCreate",

	"SysEvGroupSignal",

	"SysEvGroupRead",

	"SysEvGroupWait",

	"EvtEventAvail",

	"EvtSysEventAvail",

	"StrNCopy",

	"KeySetMask",

	"SelectDay",

	"PrefGetPreference",

	"PrefSetPreference",

	"PrefGetAppPreferences",

	"PrefSetAppPreferences",

	"FrmPointInTitle",

	"StrNCat",

	"MemCmp",

	"TblSetColumnEditIndicator",

	"FntWordWrap",

	"FldGetScrollValues",

	"SysCreateDataBaseList",

	"SysCreatePanelList",

	"DlkDispatchRequest",

	"StrPrintF",

	"StrVPrintF",

	"PrefOpenPreferenceDB",

	"SysGraffitiReferenceDialog",

	"SysKeyboardDialog",

	"FntWordWrapReverseNLines",

	"FntGetScrollValues",

	"TblSetRowStaticHeight",

	"TblHasScrollBar",

	"SclGetScrollBar",

	"FldGetNumberOfBlankLines",

	"SysTicksPerSecond",

	"HwrBacklight",

	"DmDatabaseProtect",

	"TblSetBounds",

	"StrNCompare",

	"StrNCaselessCompare",

	"PhoneNumberLookup",

	"FrmSetMenu",

	"EncDigestMD5",

	"DmFindSortPosition",

	"SysBinarySearch",

	"SysErrString",

	"SysStringByIndex",

	"EvtAddUniqueEventToQueue",

	"StrLocalizeNumber",

	"StrDelocalizeNumber",

	"LocGetNumberSeparators",

	"MenuSetActiveMenuRscID",

	"LstScrollList",

	"CategoryInitialize",

	"EncDigestMD4",

	"EncDES",

	"LstGetVisibleItems",

	"WinSetWindowBounds",

	"CategorySetName",

	"FldSetInsertionPoint",

	"FrmSetObjectBounds",

	"WinSetColors",

	"FlpDispatch",

	"FlpEmDispatch",

	"ExgInit",

	"ExgConnect",

	"ExgPut",

	"ExgGet",

	"ExgAccept",

	"ExgDisconnect",

	"ExgSend",

	"ExgReceive",

	"ExgRegisterData",

	"ExgNotifyReceive",

	"ExgControl",

	"PrgStartDialogV10",

	"PrgStopDialog",

	"PrgUpdateDialog",

	"PrgHandleEvent",

	"ImcReadFieldNoSemicolon",

	"ImcReadFieldQuotablePrintable",

	"ImcReadPropertyParameter",

	"ImcSkipAllPropertyParameters",

	"ImcReadWhiteSpace",

	"ImcWriteQuotedPrintable",

	"ImcWriteNoSemicolon",

	"ImcStringIsAscii",

	"TblGetItemFont",

	"TblSetItemFont",

	"FontSelect",

	"FntDefineFont",

	"CategoryEdit",

	"SysGetOSVersionString",

	"SysBatteryInfo",

	"SysUIBusy",

	"WinValidateHandle",

	"FrmValidatePtr",

	"CtlValidatePointer",

	"WinMoveWindowAddr",

	"FrmAddSpaceForObject",

	"FrmNewForm",

	"CtlNewControl",

	"FldNewField",

	"LstNewList",

	"FrmNewLabel",

	"FrmNewBitmap",

	"FrmNewGadget",

	"FileOpen",

	"FileClose",

	"FileDelete",

	"FileReadLow",

	"FileWrite",

	"FileSeek",

	"FileTell",

	"FileTruncate",

	"FileControl",

	"FrmActiveState",

	"SysGetAppInfo",

	"SysGetStackInfo",

	"ScrDisplayMode",

	"HwrLCDGetDepth",

	"HwrGetROMToken",

	"DbgControl",

	"ExgDBRead",

	"ExgDBWrite",

	"HostControl",

	"FrmRemoveObject",

	"SysReserved1",

	"SysReserved2",

	"SysReserved3",

	"SysReserved4",

	"HwrLCDContrast",

	"SysLCDContrast",

	"ContrastAdjust",

	"HwrDockStatus",

	"FntWidthToOffset",

	"SelectOneTime",

	"WinDrawChar",

	"WinDrawTruncChars",

	"NotifyInit",

	"NotifyRegister",

	"NotifyUnregister",

	"NotifyBroadcast",

	"NotifyBroadcastDeferred",

	"NotifyDatabaseAdded",

	"NotifyDatabaseRemoved",

	"SysWantEvent",

	"SysReserved5",

	"HwrNVPrefSet",

	"HwrNVPrefGet",

	"FlashInit",

	"FlashCompress",

	"FlashErase",

	"FlashProgram",

	"AlmTimeChange",

	"ErrAlertCustom",

	"PrgStartDialog",

	"SerialDispatch",

	"HwrBattery",

	"DmGetDatabaseLockState",

	"CncGetProfileList",

	"CncGetProfileInfo",

	"CncAddProfile",

	"CncDeleteProfile",

	"FtrPtrNew",

	"FtrPtrFree",

	"FtrPtrResize",

	"SndPlaySmfResource",

	"MemPtrDataStorage",

	"ClipboardAppendItem",


// --------------------------------------------------------------------------------
//	Template Parts -- Library function names
// --------------------------------------------------------------------------------

// --------------------
// Common Library functions
// --------------------

	"SysLibName",

	"SysLibOpen",

	"SysLibClose",

	"SysLibSleep",

	"SysLibWake",


// --------------------
// HTAL Library
// --------------------

	"HtalLibOpen",

	"HtalLibClose",

	"HtalLibSleep",

	"HtalLibWake",

	"HtalLibSetOption",

	"HtalLibGetOption",

	"HtalLibControl",

	"HtalLibConnectPhase1",

	"HtalLibDisconnect",

	"HtalLibGetCommand",

	"HtalLibSendReply",

	"HtalLibCancel",

	"HtalLibMaxBlockSize",

	"HtalLibVersion",

	"HtalLibAddSegmentSizes",

	"HtalLibConnectPhase2",


// --------------------
// INet Library
// --------------------

	"INetLibOpen",

	"INetLibClose",

	"INetLibSleep",

	"INetLibWake",

	"INetLibSettingGet",

	"INetLibSettingSet",

	"INetLibGetEvent",

	"INetLibURLOpen",

	"INetLibSockRead",

	"INetLibSockWrite",

	"INetLibSockOpen",

	"INetLibSockClose",

	"INetLibSockStatus",

	"INetLibSockSettingGet",

	"INetLibSockSettingSet",

	"INetLibSockConnect",

	"INetLibURLCrack",

	"INetLibURLsAdd",

	"INetLibURLsCompare",

	"INetLibURLGetInfo",

	"INetLibSockHTTPReqCreate",

	"INetLibSockHTTPAttrSet",

	"INetLibSockHTTPReqSend",

	"INetLibSockHTTPAttrGet",

	"INetLibSockMailReqCreate",

	"INetLibSockMailAttrSet",

	"INetLibSockMailReqAdd",

	"INetLibSockMailReqSend",

	"INetLibSockMailAttrGet",

	"inetLibTrapSockMailQueryProgress",

	"INetLibCacheList",

	"INetLibCacheGetObject",

	"INetLibConfigMakeActive",

	"INetLibConfigList",

	"INetLibConfigIndexFromName",

	"INetLibConfigDelete",

	"INetLibConfigSaveAs",

	"INetLibConfigRename",

	"INetLibConfigAliasSet",

	"INetLibConfigAliasGet",


// --------------------
// IR Library
// --------------------

	"ExgLibOpen",

	"ExgLibCLose",

	"ExgLibSleep",

	"ExgLibWake",

	"ExgLibHandleEvent",

	"ExgLibConnect",

	"ExgLibAccept",

	"ExgLibDisconnect",

	"ExgLibPut",

	"ExgLibGet",

	"ExgLibSend",

	"ExgLibReceive",

	"ExgLibControl",

	"ExgLibReserved1",

	"IrBind",

	"IrUnBind",

	"IrDiscoverReq",

	"IrConnectIrLap",

	"IrDisconnectIrLap",

	"IrConnectReq",

	"IrConnectRsp",

	"IrDataReq",

	"IrLocalBusy",

	"IrMaxTxSize",

	"IrMaxRxSize",

	"IrSetDeviceInfo",

	"IrIsNoProgress",

	"IrIsRemoteBusy",

	"IrIsMediaBusy",

	"IrIsIrLapConnected",

	"IrTestReq",

	"IrIAS_Add",

	"IrIAS_Query",

	"IrIAS_SetDeviceName",

	"IrIAS_Next",

	"IrIrOpen",

	"IrHandleEvent",

	"IrWaitForEvent",


// --------------------
// Net Library
// --------------------

	"NetLibOpen",

	"NetLibCLose",

	"NetLibSleep",

	"NetLibWake",

	"NetLibAddrINToA",

	"NetLibAddrAToIN",

	"NetLibSocketOpen",

	"NetLibSocketClose",

	"NetLibSocketOptionSet",

	"NetLibSocketOptionGet",

	"NetLibSocketBind",

	"NetLibSocketConnect",

	"NetLibSocketListen",

	"NetLibSocketAccept",

	"NetLibSocketShutdown",

	"NetLibSendPB",

	"NetLibSend",

	"NetLibReceivePB",

	"NetLibReceive",

	"NetLibDmReceive",

	"NetLibSelect",

	"*NetLibPrefsGet*",

	"*NetLibPrefsSet*",

	"*NetLibDrvrWake*",

	"*NetLibInterfacePtr*",

	"NetLibMaster",

	"NetLibGetHostByName",

	"NetLibSettingGet",

	"NetLibSettingSet",

	"NetLibIFAttach",

	"NetLibIFDetach",

	"NetLibIFGet",

	"NetLibIFSettingGet",

	"NetLibIFSettingSet",

	"NetLibIFUp",

	"NetLibIFDown",

	"NetLibIFMediaUp",

	"*NetLibScriptExecute*",

	"NetLibGetHostByAddr",

	"NetLibGetServByName",

	"NetLibGetHostByAddr",

	"NetLibFinishCloseWait",

	"NetLibGetMailExchangeByName",

	"*NetLibPrefsAppend*",

	"*NetLibIFMediaDown*",

	"NetLibOpenCount",

	"NetLibTracePrintF",

	"NetLibTracePutS",

	"NetLibOpenIfCloseWait",

	"NetLibHandlePowerOff",

	"NetLibConnectionRefresh",

	"NetLibBitMove",

	"NetLibBitPutFixed",

	"NetLibBitGetFixed",

	"NetLibBitPutUIntV",

	"NetLibBitGetUIntV",

	"NetLibBitPutIntV",

	"NetLibBitGetIntV",

	"NetLibOpenConfig",

	"NetLibConfigMakeActive",

	"NetLibConfigList",

	"NetLibConfigIndexFromName",

	"NetLibConfigDelete",

	"NetLibConfigSaveAs",

	"NetLibConfigRename",

	"NetLibConfigAliasSet",

	"NetLibConfigAliasGet",


// --------------------
// NetPlugIn Library
// --------------------

	"NPILibOpen",

	"NPILibClose",

	"NPILibSleep",

	"NPILibWake",

	"NPILibInfo",

	"NPILibSocketOpen",

	"NPILibSocketClose",

	"NPILibSocketOptionSet",

	"NPILibSocketOptionGet",

	"NPILibSocketBind",

	"NPILibSocketConnect",

	"NPILibSocketListen",

	"NPILibSocketAccept",

	"NPILibSocketShutdown",

	"NPILibSocketAddr",

	"NPILibSocketNativeRefnum",

	"NPILibSocketReady",

	"NPILibSocketReceivePB",

	"NPILibSocketSendPB",


// --------------------
// Rail Library
// --------------------

	"RailLibOpen",

	"RailLibClose",

	"RailLibSleep",

	"RailLibWake",


// --------------------
// Security Library
// --------------------

	"SecLibOpen",

	"SecLibClose",

	"SecLibSleep",

	"SecLibWake",

	"SecLibGetContextSize",

	"SecLibResetSeqNum",

	"SecLibGetSignedPublicKey",

	"SecLibProcessSignedKey",

	"SecLibEncryptBegin",

	"SecLibEncrypt",

	"SecLibEncryptEnd",

	"SecLibDecryptBegin",

	"SecLibDecrypt",

	"SecLibDecryptEnd",

	"SecLibDebug",

	"SecRamEncrypt",

	"SecRamDecrypt",

	"SecLibSetKeyPath",


// --------------------
// Serial Library
// --------------------

	"SerLibOpen",

	"SerLibClose",

	"SerLibSleep",

	"SerLibWake",

	"SerGetSettings",

	"SerSetSettings",

	"SerGetStatus",

	"SerClearErr",

	"SerSend10",

	"SerSendWait",

	"SerSendCheck",

	"SerSendFlush",

	"SerReceive10",

	"SerReceiveWait",

	"SerReceiveCheck",

	"SerReceiveFlush",

	"SerSetReceiveBuffer",

	"SerReceiveWindowOpen",

	"SerReceiveWindowClose",

	"SerSetWakeupHandler",

	"SerPrimeWakeupHandler",

	"SerControl",

	"SerSend",

	"SerReceive",


// --------------------
// Web Library
// --------------------

	"WebLibOpen",

	"WebLibClose",

	"WebLibSleep",

	"WebLibWake",

	"WebLibSettingGet",

	"WebLibSettingSet",

	"WebLibFormHandleEvent",

	"WebLibHandleEvent",

	"WebLibRender",

	"WebLibRenderCache",

	"WebLibRenderCancel",

	"WebLibCopyToClipboard",

	"WebLibGetScrollData",

	"WebLibScroll",

	"WebLibCMLToSimpleText",

	"WebLibSimpleTextToCML",

	"WebLibSelectAll",

	"WebLibRedrawForm",

	"WebLibRenderComplete",

	"WebLibRenderData",


// --------------------------------------------------------------------------------
//	Template Parts -- Error descriptions
// --------------------------------------------------------------------------------

// NOTE: the following is commented with C++ comments instead of C comments
// because the included MPW script contains a */ that prematurely closes
// the comment.
//
//	The following strings were generated as follows.  First, the following
//	lines were selected in the MPW Shell and executed:
//
//		for f in `files -f -s -r "{root}"`
//			continue if ("{f}" =~ /CMServer/)		# duplicate cmp error codes with CMClient.h
//			continue if ("{f}" =~ /SerialMgr/)	# duplicate ser error codes with SerialMgrNew.h
//			continue if ("{f}" =~ /DLClient/)		# duplicate dlk error codes with DLServer.h
//			continue if ("{f}" =~ /PadServer/)	# duplicate pad error codes with PadWS.h
//			search -q -ns /#defineŶ(ErrorClassŶ|/ "{f}"
//		end
//
//	Next, the output was selected and pasted into a new MPW window. Then
//	the following lines were selected in the MPW Shell and executed:
//
//		# Put everthing into ID/ENGLISH format
//		find 
//		replace -c  /#define[ t]+([ t]+)1Ŷ(([a-z0-9]+)2[ t]*|[ t]*([0-9]+)3)()4/ "ID=kStr_PalmOSErrorBase+2+3nENGLISH=14n"
//
//		# Convert any trailing comments (C++ version)
//		find 
//		replace -c  /[ t]*//[ t]*/ " -- "
//
//		# Convert any trialing comments (C version)
//		find 
//		replace -c  /[ t]*/*[ t]()1[ t]*// " -- 1"
//
//		# Remove any trialing periods in comments
//		find 
//		replace -c  /./ ""



	"txtErrUknownTranslitOp",

	"txtErrTranslitOverrun",

	"txtErrTranslitOverflow",

	"tsmErrUnimplemented",

	"tsmErrNeedCommit",

	"tsmErrCantCommit",

	"tsmErrNotOpen",

	"tsmErrStillOpen",

	"tsmErrWrongAPI",

	"tsmErrWrongEncoding",

	"tsmErrWrongLanguage",

	"tsmErrReentrancy",

	"tsmErrCustom",

	"almErrMemory -- ran out of memory",

	"almErrFull -- alarm table is full",

	"cmErrParam -- bad parameter",

	"cmErrTimeOut -- connection listenning/initialization timed out",

	"cmErrComm -- communication(send/receive) error",

	"cmErrCommVersion -- incompatible comm version",

	"cmErrMemory -- insufficient memory error",

	"cmErrCommBusy -- PAD server is already in use",

	"cmErrUserCan -- attempt cancelled by user",

	"cncErrAddProfileFailed -- Add profile attempt failed",

	"cncErrProfileListFull -- Add attempt failed because the",

	"cncErrGetProfileFailed -- Get profile attempt failed",

	"cncErrConDBNotFound -- Connection database not found",

	"cncErrGetProfileListFailed -- Could not get profile list",

	"cncErrProfileReadOnly -- The profile can not be altered",

	"cncErrProfileNotFound -- The profile could not be found",

	"dmErrMemError",

	"dmErrIndexOutOfRange",

	"dmErrInvalidParam",

	"dmErrReadOnly",

	"dmErrDatabaseOpen",

	"dmErrCantOpen",

	"dmErrCantFind",

	"dmErrRecordInWrongCard",

	"dmErrCorruptDatabase",

	"dmErrRecordDeleted",

	"dmErrRecordArchived",

	"dmErrNotRecordDB",

	"dmErrNotResourceDB",

	"dmErrROMBased",

	"dmErrRecordBusy",

	"dmErrResourceNotFound",

	"dmErrNoOpenDatabase",

	"dmErrInvalidCategory",

	"dmErrNotValidRecord",

	"dmErrWriteOutOfBounds",

	"dmErrSeekFailed",

	"dmErrAlreadyOpenForWrites",

	"dmErrOpenedByAnotherTask",

	"dmErrUniqueIDNotFound",

	"dmErrAlreadyExists",

	"dmErrInvalidDatabaseName",

	"dmErrDatabaseProtected",

	"dlkErrParam -- invalid parameter",

	"dlkErrMemory -- memory allocation error",

	"dlkErrNoSession -- could not establish a session	",

	"dlkErrSizeErr -- reply length was too big",

	"dlkErrLostConnection -- lost connection",

	"dlkErrInterrupted -- sync was interrupted (see sync state)",

	"dlkErrUserCan -- cancelled by user",

	"exgMemError",

	"exgErrStackInit -- stack could not initialize",

	"exgErrUserCancel",

	"exgErrNoReceiver -- receiver device not found",

	"exgErrNoKnownTarget -- can't find a target app",

	"exgErrTargetMissing -- target app is known but missing",

	"exgErrNotAllowed -- operation not allowed",

	"exgErrBadData -- internal data was not valid",

	"exgErrAppError -- generic application error",

	"exgErrUnknown -- unknown general error",

	"exgErrDeviceFull -- device is full",

	"exgErrDisconnected -- link disconnected",

	"exgErrNotFound -- requested object not found",

	"exgErrBadParam -- bad parameter to call",

	"exgErrNotSupported -- operation not supported by this library",

	"exgErrDeviceBusy -- device is busy",

	"exgErrBadLibrary -- bad or missing ExgLibrary",

	"ftrErrInvalidParam",

	"ftrErrNoSuchFeature",

	"ftrErrAlreadyExists",

	"ftrErrROMBased",

	"ftrErrInternalErr",

	"fileErrMemError -- out of memory error",

	"fileErrInvalidParam -- invalid parameter value passed",

	"fileErrCorruptFile -- the file is corrupted/invalid/not a stream file",

	"fileErrNotFound -- couldn't find the file",

	"fileErrTypeCreatorMismatch -- file's type and creator didn't match those expected",

	"fileErrReplaceError -- couldn't replace an existing file",

	"fileErrCreateError -- couldn't create a new file",

	"fileErrOpenError -- generic open error",

	"fileErrInUse -- file couldn't be opened or deleted because it is in use",

	"fileErrReadOnly -- couldn't open in write mode because db is read-only",

	"fileErrInvalidDescriptor -- invalid file descriptor (FileHandle)",

	"fileErrCloseError -- error closing the database",

	"fileErrOutOfBounds -- attempted operation went out of bounds of the file",

	"fileErrPermissionDenied -- couldn't write to a file open for read-only access",

	"fileErrIOError -- general I/O error",

	"fileErrEOF -- end-of-file error",

	"fileErrNotStream -- attempted to open a file that is not a stream",

	"flshErrGeneralError",

	"flshErrDeviceUnsupported",

	"flshErrDeviceError",

	"flshErrVerifyFailed",

	"flshErrParameterError",

	"flshErrDeviceFull",

	"flshErrNotFound",

	"fplErrOutOfRange",

	"grfErrBadParam",

	"grfErrPointBufferFull",

	"grfErrNoGlyphTable",

	"grfErrNoDictionary",

	"grfErrNoMapping",

	"grfErrMacroNotFound",

	"grfErrDepthTooDeep",

	"grfErrMacroPtrTooSmall",

	"grfErrNoMacros",

	"grfErrMacroIncomplete -- (grfWarningOffset+1)",

	"grfErrBranchNotFound -- (grfWarningOffset+2)",

	"htalErrTimeOut -- call timed out(INTERNAL ERROR CODE)",

	"htalErrParam -- invalid parameter",

	"htalErrInUse -- HTAL library is already in use",

	"htalErrMemory -- not enough memory",

	"htalErrUserCan -- cancelled by user",

	"htalErrSizeErr -- reply block is too big",

	"htalErrNotConnected -- lost/could not establish connection",

	"htalErrNotOpen -- library is not open",

	"htalErrInterfaceBusy -- comm interface(serial port, TCP/IP, etc.) is busy",

	"htalErrCommSetup -- comm setup error",

	"htalErrRemoteConnect -- could not establish remote connection and error",

	"htalErrCommVersion -- comm version is incompatible with the desktop",

	"htalErrRmtMemory -- not enough memory on remote device",

	"htalErrDestHostName -- invalid destination host name, or host name not",

	"htalErrGotTickle -- INTERNAL error code indicating that a keep-alive",

	"htalErrExtLoopback -- External loopback was detected -- this error code",

	"inetErrTooManyClients -- Too many clients already",

	"inetErrHandleInvalid -- Invalid inetH or sockH",

	"inetErrParamsInvalid -- ",

	"inetErrURLVersionInvalid -- ",

	"inetErrURLBufTooSmall -- ",

	"inetErrURLInvalid -- ",

	"inetErrTooManySockets -- ",

	"inetErrNoRequestCreated",

	"inetErrNotConnected",

	"inetErrInvalidRequest",

	"inetErrNeedTime",

	"inetErrHostnameInvalid",

	"inetErrInvalidPort",

	"inetErrInvalidHostAddr",

	"inetErrNilBuffer",

	"inetErrConnectTimeout",

	"inetErrResolveTimeout",

	"inetErrSendReqTimeout",

	"inetErrReadTimeout",

	"inetErrBufTooSmall",

	"inetErrSchemeNotSupported",

	"inetErrInvalidResponse",

	"inetErrSettingTooLarge",

	"inetErrSettingSizeInvalid",

	"inetErrRequestTooLong",

	"inetErrSettingNotImplemented",

	"inetErrConfigNotFound",

	"inetErrConfigCantDelete",

	"inetErrConfigTooMany",

	"inetErrConfigBadName",

	"inetErrConfigNotAlias",

	"inetErrConfigCantPointToAlias",

	"inetErrConfigEmpty",

	"inetErrConfigAliasErr",

	"inetErrNoWirelessInterface",

	"inetErrEncryptionNotAvail",

	"inetErrNeedRetryEncSeqNum",

	"inetErrNeedRetryEncPublicKey",

	"inetErrResponseTooShort",

	"inetErrMobitexIllegalOKHost",

	"inetErrMobitexIllegalBadHost",

	"inetErrHTTPBadRequest",

	"inetErrHTTPUnauthorized",

	"inetErrHTTPForbidden",

	"inetErrHTTPNotFound",

	"inetErrHTTPMethodNotAllowed",

	"inetErrHTTPNotAcceptable",

	"inetErrHTTPProxyAuthRequired",

	"inetErrHTTPRequestTimeout",

	"inetErrHTTPConflict",

	"inetErrHTTPGone",

	"inetErrHTTPLengthRequired",

	"inetErrHTTPPreconditionFailed",

	"inetErrHTTPRequestTooLarge",

	"inetErrHTTPRequestURITooLong",

	"inetErrHTTPUnsupportedType",

	"inetErrHTTPServerError",

	"inetErrCTPServerError",

	"inetErrTypeNotCached",

	"inetErrCacheInvalid",

	"inetErrURLDispatched",

	"inetErrDatabaseNotFound",

	"inetErrCTPMalformedRequest",

	"inetErrCTPUnknownCommand",

	"inetErrCTPTruncated",

	"inetErrCTPUnknownError",

	"inetErrCTPProxyError",

	"inetErrCTPSocketErr",

	"inetErrCTPInvalidURL",

	"inetErrCTPReferringPageOutOfDate",

	"inetErrCTPBadRequest",

	"inetErrUNUSED",

	"inetErrCTPMailServerDown",

	"inetErrCTPHostNotFound",

	"inetErrCTPContentInvalidTag",

	"inetErrCTPContentInternal",

	"inetErrCTPContentDataEnd",

	"inetErrCTPContentResourceTooBig",

	"inetErrCTPContentNoNoFrames",

	"inetErrCTPContentUnsupportedContent",

	"inetErrCTPContentUnsupportedEncoding",

	"inetErrCTPContentBadForm",

	"inetErrCTPContentBadFormMissingAction",

	"inetErrCTPContentBadFormMissingMethod",

	"inetErrCTPContentNoSourceData",

	"inetErrCTPContentBadImage",

	"inetErrCTPContentImageTooLarge",

	"inetErrMobitexErrorHandled",

	"inetErrProxyDownBadHost",

	"inetErrHostConnectionLost",

	"inetErrLinkNotFound",

	"memErrChunkLocked",

	"memErrNotEnoughSpace",

	"memErrInvalidParam -- invalid param or requested size is too big",

	"memErrChunkNotLocked",

	"memErrCardNotPresent",

	"memErrNoCardHeader",

	"memErrInvalidStoreHeader",

	"memErrRAMOnlyCard",

	"memErrWriteProtect",

	"memErrNoRAMOnCard",

	"memErrNoStore",

	"mdmErrNoTone -- no dial tone",

	"mdmErrNoDCD -- no carrier / timeout",

	"mdmErrBusy -- busy signal heard",

	"mdmErrUserCan -- cancelled by user",

	"mdmErrCmdError -- command error",

	"mdmErrNoModem -- no modem detected",

	"mdmErrMemory -- not enough memory",

	"mdmErrPrefs -- modem preferences have not been",

	"mdmErrDial -- dial command error - most likely the dial",

	"mdmErrNoPhoneNum -- No phone number and not ""Direct Connect""",

	"netErrAlreadyOpen",

	"netErrNotOpen",

	"netErrStillOpen",

	"netErrParamErr",

	"netErrNoMoreSockets",

	"netErrOutOfResources",

	"netErrOutOfMemory",

	"netErrSocketNotOpen",

	"netErrSocketBusy -- EINPROGRESS",

	"netErrMessageTooBig",

	"netErrSocketNotConnected",

	"netErrNoInterfaces -- ENETUNREACH",

	"netErrBufTooSmall",

	"netErrUnimplemented",

	"netErrPortInUse -- EADDRINUSE",

	"netErrQuietTimeNotElapsed -- EADDRINUSE",

	"netErrInternal",

	"netErrTimeout -- ETIMEDOUT",

	"netErrSocketAlreadyConnected -- EISCONN",

	"netErrSocketClosedByRemote",

	"netErrOutOfCmdBlocks",

	"netErrWrongSocketType",

	"netErrSocketNotListening",

	"netErrUnknownSetting",

	"netErrInvalidSettingSize",

	"netErrPrefNotFound",

	"netErrInvalidInterface",

	"netErrInterfaceNotFound",

	"netErrTooManyInterfaces",

	"netErrBufWrongSize",

	"netErrUserCancel",

	"netErrBadScript",

	"netErrNoSocket",

	"netErrSocketRcvBufFull",

	"netErrNoPendingConnect",

	"netErrUnexpectedCmd",

	"netErrNoTCB",

	"netErrNilRemoteWindowSize",

	"netErrNoTimerProc",

	"netErrSocketInputShutdown -- EOF to sockets API",

	"netErrCmdBlockNotCheckedOut		 ",

	"netErrCmdNotDone		 ",

	"netErrUnknownProtocol		 ",

	"netErrUnknownService		 ",

	"netErrUnreachableDest	",

	"netErrReadOnlySetting	 ",

	"netErrWouldBlock -- EWOULDBLOCK",

	"netErrAlreadyInProgress -- EALREADY",

	"netErrPPPTimeout",

	"netErrPPPBroughtDown",

	"netErrAuthFailure",

	"netErrPPPAddressRefused",

	"netErrDNSNameTooLong",

	"netErrDNSBadName",

	"netErrDNSBadArgs",

	"netErrDNSLabelTooLong",

	"netErrDNSAllocationFailure",

	"netErrDNSTimeout",

	"netErrDNSUnreachable",

	"netErrDNSFormat",

	"netErrDNSServerFailure",

	"netErrDNSNonexistantName",

	"netErrDNSNIY",

	"netErrDNSRefused",

	"netErrDNSImpossible",

	"netErrDNSNoRRS",

	"netErrDNSAborted",

	"netErrDNSBadProtocol",

	"netErrDNSTruncated",

	"netErrDNSNoRecursion",

	"netErrDNSIrrelevant",

	"netErrDNSNotInLocalCache",

	"netErrDNSNoPort",

	"netErrIPCantFragment",

	"netErrIPNoRoute",

	"netErrIPNoSrc",

	"netErrIPNoDst",

	"netErrIPktOverflow",

	"netErrTooManyTCPConnections",

	"netErrNoDNSServers",

	"netErrInterfaceDown",

	"netErrNoChannel -- The datalink layer cannot acquire a channel ",

	"netErrDieState -- Mobitex network has issued a DIE command",

	"netErrReturnedInMail -- The addressed of the transmitted packet was not available, and the message was placed in the network's mailbox",

	"netErrReturnedNoTransfer -- This message cannot be transferred or put in the network mailbox",

	"netErrReturnedIllegal -- The message could not be switched to the network",

	"netErrReturnedCongest -- Line, radio channels, or network nodes are congested",

	"netErrReturnedError -- Technical error in the network",

	"netErrReturnedBusy -- The B-party is busy",

	"netErrGMANState -- The modem has not registered with the network",

	"netErrQuitOnTxFail -- Couldn't get packet through, shutdown",

	"netErrFlexListFull -- raw IF error message: see Mobitex spec",

	"netErrSenderMAN -- ditto",

	"netErrIllegalType -- ditto",

	"netErrIllegalState -- ditto",

	"netErrIllegalFlags -- ditto",

	"netErrIllegalSendlist -- ditto",

	"netErrIllegalMPAKLength -- ditto",

	"netErrIllegalAddressee -- ditto",

	"netErrIllegalPacketClass -- ditto",

	"netErrBufferLength -- any ",

	"netErrNiCdLowBattery -- any ",

	"netErrRFinterfaceFatal -- any",

	"netErrIllegalLogout -- raw IF error message",

	"netErrAAARadioLoad -- 7/20/98 JB.  If there is insufficient AAA",

	"netErrAntennaDown",

	"netErrNiCdCharging -- just for charging",

	"netErrAntennaWentDown",

	"netErrNotActivated -- The unit has not been FULLY activated.  George and Morty completed",

	"netErrRadioTemp -- Radio's temp is too high for FCC compliant TX",

	"netErrNiCdChargeError -- Charging stopped due to NiCd charging characteristic",

	"netErrNiCdSag -- the computed sag or actual sag indicates a NiCd with diminished capacity",

	"netErrNiCdChargeSuspend -- Charging has been suspended due to low AAA batteries",

	"netErrConfigNotFound",

	"netErrConfigCantDelete",

	"netErrConfigTooMany",

	"netErrConfigBadName",

	"netErrConfigNotAlias",

	"netErrConfigCantPointToAlias",

	"netErrConfigEmpty",

	"netErrAlreadyOpenWithOtherConfig",

	"netErrConfigAliasErr",

	"netErrNoMultiPktAddr",

	"netErrOutOfPackets ",

	"netErrMultiPktAddrReset",

	"netErrStaleMultiPktAddr",

	"netErrScptPluginMissing",

	"netErrScptPluginLaunchFail",

	"netErrScptPluginCmdFail",

	"netErrScptPluginInvalidCmd",

	"flpErrOutOfRange",

	"pmErrParam -- invalid parameter",

	"pmErrTooManyRetries -- too many retries",

	"pmErrTimeOut -- call timed out",

	"pmErrInUse -- PAD Server/WS manager is in use",

	"pmErrMemory -- not enough memory",

	"pmErrUserCan -- cancelled by user",

	"pmErrSizeErr -- reply block is too big",

	"pmErrBlockFormat -- block format error",

	"pmErrBufTooSmall -- buffer is too small",

	"pmErrRemoteMemory -- remote memory error",

	"penErrBadParam",

	"secErrGeneral",

	"secErrCerticom",

	"secErrUsage",

	"secErrMicMismatch",

	"secErrSeqNum",

	"secErrKeyNotFound",

	"secErrKeyVerMismatch",

	"secErrBfrTooSmall",

	"secErrDataSize -- Error in call to sb_dataSize",

	"secErrDataTooLarge -- datasize too large",

	"secErrInitialize -- Error in call to sb_initialize",

	"secErrMemory -- Cannot allocate needed memory",

	"secErrAlreadyOpen -- Warning: library already open",

	"secErrNotOpen -- LIbrary not open",

	"secErrDBInit -- Could not init needed database",

	"secErrLibClosed -- JB 9/24/98 if the Mobitex stack needs",

	"slkErrChecksum",

	"slkErrFormat",

	"slkErrBuffer",

	"slkErrTimeOut",

	"slkErrHandle",

	"slkErrBodyLimit",

	"slkErrTransId",

	"slkErrResponse",

	"slkErrNoDefaultProc",

	"slkErrWrongPacketType",

	"slkErrBadParam",

	"slkErrAlreadyOpen",

	"slkErrOutOfSockets",

	"slkErrSocketNotOpen",

	"slkErrWrongDestSocket",

	"slkErrWrongPktType",

	"slkErrBusy -- called while sending a packet",

	"slkErrNotOpen",

	"sndErrBadParam",

	"sndErrBadChannel",

	"sndErrMemory",

	"sndErrOpen",

	"sndErrQFull",

	"sndErrQEmpty -- internal",

	"sndErrFormat -- unsupported data format",

	"sndErrBadStream -- invalid data stream",

	"sndErrInterrupted -- play was interrupted",

	"evtErrParamErr",

	"evtErrQueueFull",

	"evtErrQueueEmpty",

	"sysErrTimeout",

	"sysErrParamErr",

	"sysErrNoFreeResource",

	"sysErrNoFreeRAM",

	"sysErrNotAllowed",

	"sysErrSemInUse",

	"sysErrInvalidID",

	"sysErrOutOfOwnerIDs",

	"sysErrNoFreeLibSlots",

	"sysErrLibNotFound",

	"sysErrDelayWakened -- SysTaskDelay wakened by SysTaskWake before delay completed",

	"sysErrRomIncompatible",

	"sysErrBufTooSmall",

	"sysErrPrefNotFound",

	"sysNotifyErrEntryNotFound -- could not find registration entry in the list",

	"sysNotifyErrDuplicateEntry -- identical entry already exists",

	"sysNotifyErrBroadcastBusy -- a broadcast is already in progress - try again later",

	"sysNotifyErrBroadcastCancelled -- a handler cancelled the broadcast",

	"sysErrMbId",

	"sysErrMbNone	",

	"sysErrMbBusy",

	"sysErrMbFull",

	"sysErrMbDepth",

	"sysErrMbEnv",

	"pwrErrNone",

	"pwrErrBacklight",

	"pwrErrRadio",

	"pwrErrBeam",

	"timErrMemory",

	"webErrBufTooSmall -- Buffer too small",

	"webErrTooComplex -- Page too complex",

	"webErrCMLEnd -- Page done",

	"webErrCMLInvalid -- Invalid CML",

	"webErrUserCancel -- User initiated cancel",

	"webErrOutOfMemory -- ",

	"webErrBadHandle -- Invalid Handle",

	"webErrParseOverrun -- Parsing past end of partial CML",

	"webErrInvalidParam -- Invalid parameter",

	"webErrCMLRestart -- Internal error",

	"webErrCMLInvalidTable -- Premature table tag",

	"webErrCMLInvalidTD -- Premature table cell begin tag",

	"webErrCMLInvalidTDEnd -- Premature table cell end tag",

	"webErrCMLInvalidSelect -- Invalid select object type",

	"webErrCMLInvalidEnd -- Invalid end tag",

	"webErrCMLInvalidVersion -- Incompatable encoder version",

	"webErrCMLInvalidNested -- Nested table (not allowed)",


	0
};


void _ResStrTableInit( void )
{
	_ResStrIndex[kStr_SysTrapBase+872] = 1081;
	_ResStrIndex[kStr_SysTrapBase+873] = 1082;
	_ResStrIndex[kStr_SysTrapBase+874] = 1083;
	_ResStrIndex[kStr_SysTrapBase+875] = 1084;
	_ResStrIndex[kStr_SysTrapBase+876] = 1085;
	_ResStrIndex[kStr_SysTrapBase+877] = 1086;
	_ResStrIndex[kStr_SysTrapBase+878] = 1087;
	_ResStrIndex[kStr_SysTrapBase+879] = 1088;
	_ResStrIndex[kStr_OffscreenFormObject] = 24;
	_ResStrIndex[kStr_EnterKey] = 105;
	_ResStrIndex[kStr_IrLibTrapBase+10] = 1160;
	_ResStrIndex[kStr_IrLibTrapBase+11] = 1161;
	_ResStrIndex[kStr_IrLibTrapBase+12] = 1162;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+1] = 1397;
	_ResStrIndex[kStr_IrLibTrapBase+13] = 1163;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+2] = 1398;
	_ResStrIndex[kStr_IrLibTrapBase+14] = 1164;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+3] = 1399;
	_ResStrIndex[kStr_IrLibTrapBase+15] = 1165;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+4] = 1400;
	_ResStrIndex[kStr_IrLibTrapBase+16] = 1166;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+5] = 1401;
	_ResStrIndex[kStr_IrLibTrapBase+17] = 1167;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+6] = 1402;
	_ResStrIndex[kStr_IrLibTrapBase+18] = 1168;
	_ResStrIndex[kStr_PalmOSErrorBase+dlkErrorClass+7] = 1403;
	_ResStrIndex[kStr_IrLibTrapBase+19] = 1169;
	_ResStrIndex[kStr_SysTrapBase+880] = 1089;
	_ResStrIndex[kStr_CurrentAppUC] = 51;
	_ResStrIndex[kStr_OpError] = 0;
	_ResStrIndex[kStr_NeedMoreRAM] = 142;
	_ResStrIndex[kStr_IrLibTrapBase+20] = 1170;
	_ResStrIndex[kStr_IrLibTrapBase+21] = 1171;
	_ResStrIndex[kStr_IrLibTrapBase+22] = 1172;
	_ResStrIndex[kStr_IrLibTrapBase+23] = 1173;
	_ResStrIndex[kStr_IrLibTrapBase+24] = 1174;
	_ResStrIndex[kStr_UnknownErrorCode] = 72;
	_ResStrIndex[kStr_IrLibTrapBase+25] = 1175;
	_ResStrIndex[kStr_IrLibTrapBase+26] = 1176;
	_ResStrIndex[kStr_IrLibTrapBase+27] = 1177;
	_ResStrIndex[kStr_IrLibTrapBase+28] = 1178;
	_ResStrIndex[kStr_IrLibTrapBase+29] = 1179;
	_ResStrIndex[kStr_IrLibTrapBase+30] = 1180;
	_ResStrIndex[kStr_IrLibTrapBase+31] = 1181;
	_ResStrIndex[kStr_IrLibTrapBase+32] = 1182;
	_ResStrIndex[kStr_IrLibTrapBase+33] = 1183;
	_ResStrIndex[kStr_IrLibTrapBase+34] = 1184;
	_ResStrIndex[kStr_IrLibTrapBase+35] = 1185;
	_ResStrIndex[kStr_CmdQuit] = 92;
	_ResStrIndex[kStr_IrLibTrapBase+36] = 1186;
	_ResStrIndex[kStr_IrLibTrapBase+37] = 1187;
	_ResStrIndex[kStr_IrLibTrapBase+38] = 1188;
	_ResStrIndex[kStr_GlobalsAccess] = 4;
	_ResStrIndex[kStr_RegisterAccess] = 2;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+10] = 1379;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+11] = 1380;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+12] = 1381;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+13] = 1382;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+14] = 1383;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+15] = 1384;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+16] = 1385;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+17] = 1386;
	_ResStrIndex[kStr_SecLibTrapBase+1] = 1279;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+18] = 1387;
	_ResStrIndex[kStr_SecLibTrapBase+2] = 1280;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+19] = 1388;
	_ResStrIndex[kStr_SecLibTrapBase+3] = 1281;
	_ResStrIndex[kStr_SecLibTrapBase+4] = 1282;
	_ResStrIndex[kStr_SecLibTrapBase+5] = 1283;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+1] = 1443;
	_ResStrIndex[kStr_SecLibTrapBase+6] = 1284;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+2] = 1444;
	_ResStrIndex[kStr_SecLibTrapBase+7] = 1285;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+3] = 1445;
	_ResStrIndex[kStr_SecLibTrapBase+8] = 1286;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+4] = 1446;
	_ResStrIndex[kStr_SecLibTrapBase+9] = 1287;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+5] = 1447;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+6] = 1448;
	_ResStrIndex[kStr_PalmOSErrorBase+flshErrorClass+7] = 1449;
	_ResStrIndex[kStr_FreeChunkAccess] = 10;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+20] = 1389;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+21] = 1390;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+22] = 1391;
	_ResStrIndex[kStr_SANEUsage] = 16;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+23] = 1392;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+24] = 1393;
	_ResStrIndex[kStr_DiskFull] = 115;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+25] = 1394;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+26] = 1395;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+27] = 1396;
	_ResStrIndex[kStr_GremlinStarted] = 32;
	_ResStrIndex[kStr_Debug] = 59;
	_ResStrIndex[kStr_MemErrNotEnoughSpace] = 130;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+1] = 1721;
	_ResStrIndex[kStr_FileNotFound] = 120;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+2] = 1722;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+4] = 1723;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+5] = 1724;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+6] = 1725;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+7] = 1726;
	_ResStrIndex[kStr_CmdProfileStart] = 101;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+8] = 1727;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+9] = 1728;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+129] = 1460;
	_ResStrIndex[kStr_WrittenTo] = 50;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+130] = 1461;
	_ResStrIndex[kStr_NetLibTrapBase+10] = 1198;
	_ResStrIndex[kStr_NetLibTrapBase+11] = 1199;
	_ResStrIndex[kStr_NetLibTrapBase+12] = 1200;
	_ResStrIndex[kStr_NetLibTrapBase+13] = 1201;
	_ResStrIndex[kStr_NetLibTrapBase+14] = 1202;
	_ResStrIndex[kStr_NetLibTrapBase+15] = 1203;
	_ResStrIndex[kStr_NetLibTrapBase+16] = 1204;
	_ResStrIndex[kStr_NetLibTrapBase+17] = 1205;
	_ResStrIndex[kStr_NetLibTrapBase+18] = 1206;
	_ResStrIndex[kStr_NetLibTrapBase+19] = 1207;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+1] = 1478;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+2] = 1479;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+3] = 1480;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+4] = 1481;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+5] = 1482;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+6] = 1483;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+7] = 1484;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+8] = 1485;
	_ResStrIndex[kStr_SerLibTrapBase+1] = 1297;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+9] = 1486;
	_ResStrIndex[kStr_SerLibTrapBase+2] = 1298;
	_ResStrIndex[kStr_SerLibTrapBase+3] = 1299;
	_ResStrIndex[kStr_SerLibTrapBase+4] = 1300;
	_ResStrIndex[kStr_SerLibTrapBase+5] = 1301;
	_ResStrIndex[kStr_SerLibTrapBase+6] = 1302;
	_ResStrIndex[kStr_SerLibTrapBase+7] = 1303;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+128] = 1353;
	_ResStrIndex[kStr_SerLibTrapBase+8] = 1304;
	_ResStrIndex[kStr_SerLibTrapBase+9] = 1305;
	_ResStrIndex[kStr_SaveBeforeQuitting] = 40;
	_ResStrIndex[kStr_NetLibTrapBase+20] = 1208;
	_ResStrIndex[kStr_NetLibTrapBase+21] = 1209;
	_ResStrIndex[kStr_NetLibTrapBase+22] = 1210;
	_ResStrIndex[kStr_NetLibTrapBase+23] = 1211;
	_ResStrIndex[kStr_NetLibTrapBase+24] = 1212;
	_ResStrIndex[kStr_NetLibTrapBase+25] = 1213;
	_ResStrIndex[kStr_NetLibTrapBase+26] = 1214;
	_ResStrIndex[kStr_NetLibTrapBase+27] = 1215;
	_ResStrIndex[kStr_NetLibTrapBase+28] = 1216;
	_ResStrIndex[kStr_NetLibTrapBase+29] = 1217;
	_ResStrIndex[kStr_HOffsetNotInMPT] = 77;
	_ResStrIndex[kStr_SecLibTrapBase+10] = 1288;
	_ResStrIndex[kStr_SecLibTrapBase+11] = 1289;
	_ResStrIndex[kStr_SecLibTrapBase+12] = 1290;
	_ResStrIndex[kStr_SecLibTrapBase+13] = 1291;
	_ResStrIndex[kStr_SecLibTrapBase+14] = 1292;
	_ResStrIndex[kStr_SecLibTrapBase+15] = 1293;
	_ResStrIndex[kStr_SecLibTrapBase+16] = 1294;
	_ResStrIndex[kStr_SecLibTrapBase+17] = 1295;
	_ResStrIndex[kStr_SecLibTrapBase+18] = 1296;
	_ResStrIndex[kStr_Autoload] = 46;
	_ResStrIndex[kStr_NetLibTrapBase+30] = 1218;
	_ResStrIndex[kStr_NetLibTrapBase+31] = 1219;
	_ResStrIndex[kStr_NetLibTrapBase+32] = 1220;
	_ResStrIndex[kStr_NetLibTrapBase+33] = 1221;
	_ResStrIndex[kStr_NetLibTrapBase+34] = 1222;
	_ResStrIndex[kStr_NetLibTrapBase+35] = 1223;
	_ResStrIndex[kStr_NetLibTrapBase+36] = 1224;
	_ResStrIndex[kStr_NetLibTrapBase+37] = 1225;
	_ResStrIndex[kStr_NetLibTrapBase+38] = 1226;
	_ResStrIndex[kStr_NetLibTrapBase+39] = 1227;
	_ResStrIndex[kStr_RailLibTrapBase+1] = 1275;
	_ResStrIndex[kStr_RailLibTrapBase+2] = 1276;
	_ResStrIndex[kStr_GremlinEnded] = 33;
	_ResStrIndex[kStr_RailLibTrapBase+3] = 1277;
	_ResStrIndex[kStr_RailLibTrapBase+4] = 1278;
	_ResStrIndex[kStr_MemMgrAccess] = 6;
	_ResStrIndex[kStr_NetLibTrapBase+40] = 1228;
	_ResStrIndex[kStr_NetLibTrapBase+41] = 1229;
	_ResStrIndex[kStr_NetLibTrapBase+42] = 1230;
	_ResStrIndex[kStr_NetLibTrapBase+43] = 1231;
	_ResStrIndex[kStr_NetLibTrapBase+44] = 1232;
	_ResStrIndex[kStr_NetLibTrapBase+45] = 1233;
	_ResStrIndex[kStr_NetLibTrapBase+46] = 1234;
	_ResStrIndex[kStr_NetLibTrapBase+47] = 1235;
	_ResStrIndex[kStr_NetLibTrapBase+48] = 1236;
	_ResStrIndex[kStr_NetLibTrapBase+49] = 1237;
	_ResStrIndex[kStr_ProfROMNameAddress] = 68;
	_ResStrIndex[kStr_SysTrapBase+100] = 309;
	_ResStrIndex[kStr_SysTrapBase+101] = 310;
	_ResStrIndex[kStr_SysTrapBase+102] = 311;
	_ResStrIndex[kStr_SysTrapBase+103] = 312;
	_ResStrIndex[kStr_SysTrapBase+104] = 313;
	_ResStrIndex[kStr_SysTrapBase+105] = 314;
	_ResStrIndex[kStr_SysTrapBase+106] = 315;
	_ResStrIndex[kStr_SysTrapBase+107] = 316;
	_ResStrIndex[kStr_SysTrapBase+108] = 317;
	_ResStrIndex[kStr_SysTrapBase+109] = 318;
	_ResStrIndex[kStr_NetLibTrapBase+50] = 1238;
	_ResStrIndex[kStr_NetLibTrapBase+51] = 1239;
	_ResStrIndex[kStr_NetLibTrapBase+52] = 1240;
	_ResStrIndex[kStr_NetLibTrapBase+53] = 1241;
	_ResStrIndex[kStr_NetLibTrapBase+54] = 1242;
	_ResStrIndex[kStr_NetLibTrapBase+55] = 1243;
	_ResStrIndex[kStr_NetLibTrapBase+56] = 1244;
	_ResStrIndex[kStr_NetLibTrapBase+57] = 1245;
	_ResStrIndex[kStr_NetLibTrapBase+58] = 1246;
	_ResStrIndex[kStr_NetLibTrapBase+59] = 1247;
	_ResStrIndex[kStr_SysTrapBase+110] = 319;
	_ResStrIndex[kStr_SysTrapBase+111] = 320;
	_ResStrIndex[kStr_SysTrapBase+112] = 321;
	_ResStrIndex[kStr_SysTrapBase+113] = 322;
	_ResStrIndex[kStr_SysTrapBase+114] = 323;
	_ResStrIndex[kStr_SysTrapBase+115] = 324;
	_ResStrIndex[kStr_SysTrapBase+116] = 325;
	_ResStrIndex[kStr_SysTrapBase+117] = 326;
	_ResStrIndex[kStr_SysTrapBase+118] = 327;
	_ResStrIndex[kStr_SysTrapBase+119] = 328;
	_ResStrIndex[kStr_NetLibTrapBase+60] = 1248;
	_ResStrIndex[kStr_NetLibTrapBase+61] = 1249;
	_ResStrIndex[kStr_NetLibTrapBase+62] = 1250;
	_ResStrIndex[kStr_NetLibTrapBase+63] = 1251;
	_ResStrIndex[kStr_NetLibTrapBase+64] = 1252;
	_ResStrIndex[kStr_NetLibTrapBase+65] = 1253;
	_ResStrIndex[kStr_NetLibTrapBase+66] = 1254;
	_ResStrIndex[kStr_NetLibTrapBase+67] = 1255;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+1] = 1363;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+2] = 1364;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+3] = 1365;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+4] = 1366;
	_ResStrIndex[kStr_SysTrapBase+120] = 329;
	_ResStrIndex[kStr_PalmOSErrorBase+pwrErrorClass+0] = 1802;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+5] = 1367;
	_ResStrIndex[kStr_SysTrapBase+121] = 330;
	_ResStrIndex[kStr_PalmOSErrorBase+pwrErrorClass+1] = 1803;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+6] = 1368;
	_ResStrIndex[kStr_SysTrapBase+122] = 331;
	_ResStrIndex[kStr_PalmOSErrorBase+pwrErrorClass+2] = 1804;
	_ResStrIndex[kStr_PalmOSErrorBase+cncErrorClass+7] = 1369;
	_ResStrIndex[kStr_SysTrapBase+123] = 332;
	_ResStrIndex[kStr_PalmOSErrorBase+pwrErrorClass+3] = 1805;
	_ResStrIndex[kStr_SysTrapBase+124] = 333;
	_ResStrIndex[kStr_SysTrapBase+125] = 334;
	_ResStrIndex[kStr_SysTrapBase+126] = 335;
	_ResStrIndex[kStr_SysTrapBase+127] = 336;
	_ResStrIndex[kStr_SysTrapBase+128] = 337;
	_ResStrIndex[kStr_SysTrapBase+129] = 338;
	_ResStrIndex[kStr_SysTrapBase+130] = 339;
	_ResStrIndex[kStr_SysTrapBase+131] = 340;
	_ResStrIndex[kStr_SysTrapBase+132] = 341;
	_ResStrIndex[kStr_SysTrapBase+133] = 342;
	_ResStrIndex[kStr_SysTrapBase+134] = 343;
	_ResStrIndex[kStr_SysTrapBase+135] = 344;
	_ResStrIndex[kStr_SysTrapBase+136] = 345;
	_ResStrIndex[kStr_SysTrapBase+137] = 346;
	_ResStrIndex[kStr_SysTrapBase+138] = 347;
	_ResStrIndex[kStr_SysTrapBase+139] = 348;
	_ResStrIndex[kStr_CmdOpen] = 83;
	_ResStrIndex[kStr_CmdProfileStop] = 102;
	_ResStrIndex[kStr_SysTrapBase+300] = 509;
	_ResStrIndex[kStr_SysTrapBase+301] = 510;
	_ResStrIndex[kStr_SysTrapBase+302] = 511;
	_ResStrIndex[kStr_SysTrapBase+140] = 349;
	_ResStrIndex[kStr_PalmOSErrorBase+almErrorClass+1] = 1354;
	_ResStrIndex[kStr_SysTrapBase+303] = 512;
	_ResStrIndex[kStr_SysTrapBase+141] = 350;
	_ResStrIndex[kStr_PalmOSErrorBase+almErrorClass+2] = 1355;
	_ResStrIndex[kStr_SysTrapBase+304] = 513;
	_ResStrIndex[kStr_SysTrapBase+142] = 351;
	_ResStrIndex[kStr_SysTrapBase+305] = 514;
	_ResStrIndex[kStr_SysTrapBase+143] = 352;
	_ResStrIndex[kStr_SysTrapBase+306] = 515;
	_ResStrIndex[kStr_SysTrapBase+144] = 353;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+1] = 1580;
	_ResStrIndex[kStr_SysTrapBase+307] = 516;
	_ResStrIndex[kStr_SysTrapBase+145] = 354;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+2] = 1581;
	_ResStrIndex[kStr_SysTrapBase+308] = 517;
	_ResStrIndex[kStr_SysTrapBase+146] = 355;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+3] = 1582;
	_ResStrIndex[kStr_SysTrapBase+309] = 518;
	_ResStrIndex[kStr_SysTrapBase+147] = 356;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+4] = 1583;
	_ResStrIndex[kStr_SysTrapBase+148] = 357;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+5] = 1584;
	_ResStrIndex[kStr_SysTrapBase+149] = 358;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+6] = 1585;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+7] = 1586;
	_ResStrIndex[kStr_CmdHotSync] = 89;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+8] = 1587;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+9] = 1588;
	_ResStrIndex[kStr_SysTrapBase+310] = 519;
	_ResStrIndex[kStr_SysTrapBase+311] = 520;
	_ResStrIndex[kStr_SysTrapBase+312] = 521;
	_ResStrIndex[kStr_SysTrapBase+150] = 359;
	_ResStrIndex[kStr_SysTrapBase+313] = 522;
	_ResStrIndex[kStr_SysTrapBase+151] = 360;
	_ResStrIndex[kStr_SysTrapBase+314] = 523;
	_ResStrIndex[kStr_SysTrapBase+152] = 361;
	_ResStrIndex[kStr_SysTrapBase+315] = 524;
	_ResStrIndex[kStr_SysTrapBase+153] = 362;
	_ResStrIndex[kStr_SysTrapBase+316] = 525;
	_ResStrIndex[kStr_SysTrapBase+154] = 363;
	_ResStrIndex[kStr_SysTrapBase+317] = 526;
	_ResStrIndex[kStr_SysTrapBase+155] = 364;
	_ResStrIndex[kStr_SysTrapBase+318] = 527;
	_ResStrIndex[kStr_SysTrapBase+156] = 365;
	_ResStrIndex[kStr_SysTrapBase+319] = 528;
	_ResStrIndex[kStr_SysTrapBase+157] = 366;
	_ResStrIndex[kStr_SysTrapBase+158] = 367;
	_ResStrIndex[kStr_SysTrapBase+159] = 368;
	_ResStrIndex[kStr_SysTrapBase+320] = 529;
	_ResStrIndex[kStr_SysTrapBase+321] = 530;
	_ResStrIndex[kStr_SysTrapBase+322] = 531;
	_ResStrIndex[kStr_SysTrapBase+160] = 369;
	_ResStrIndex[kStr_SysTrapBase+323] = 532;
	_ResStrIndex[kStr_SysTrapBase+161] = 370;
	_ResStrIndex[kStr_SysTrapBase+324] = 533;
	_ResStrIndex[kStr_SysTrapBase+162] = 371;
	_ResStrIndex[kStr_SysTrapBase+325] = 534;
	_ResStrIndex[kStr_SysTrapBase+163] = 372;
	_ResStrIndex[kStr_SysTrapBase+326] = 535;
	_ResStrIndex[kStr_SysTrapBase+164] = 373;
	_ResStrIndex[kStr_SysTrapBase+327] = 536;
	_ResStrIndex[kStr_SysTrapBase+165] = 374;
	_ResStrIndex[kStr_SysTrapBase+328] = 537;
	_ResStrIndex[kStr_SysTrapBase+166] = 375;
	_ResStrIndex[kStr_SysTrapBase+329] = 538;
	_ResStrIndex[kStr_SysTrapBase+167] = 376;
	_ResStrIndex[kStr_SysTrapBase+168] = 377;
	_ResStrIndex[kStr_SysTrapBase+169] = 378;
	_ResStrIndex[kStr_LowMemAccess] = 3;
	_ResStrIndex[kStr_DiskMissing] = 116;
	_ResStrIndex[kStr_ResizeWindow] = 104;
	_ResStrIndex[kStr_SysTrapBase+330] = 539;
	_ResStrIndex[kStr_SysTrapBase+331] = 540;
	_ResStrIndex[kStr_SysTrapBase+332] = 541;
	_ResStrIndex[kStr_SysTrapBase+170] = 379;
	_ResStrIndex[kStr_SysTrapBase+333] = 542;
	_ResStrIndex[kStr_SysTrapBase+171] = 380;
	_ResStrIndex[kStr_SysTrapBase+334] = 543;
	_ResStrIndex[kStr_SysTrapBase+172] = 381;
	_ResStrIndex[kStr_ChunkTooLarge] = 75;
	_ResStrIndex[kStr_SysTrapBase+335] = 544;
	_ResStrIndex[kStr_SysTrapBase+173] = 382;
	_ResStrIndex[kStr_SysTrapBase+336] = 545;
	_ResStrIndex[kStr_SysTrapBase+174] = 383;
	_ResStrIndex[kStr_SysTrapBase+337] = 546;
	_ResStrIndex[kStr_SysTrapBase+175] = 384;
	_ResStrIndex[kStr_SysTrapBase+338] = 547;
	_ResStrIndex[kStr_SysTrapBase+176] = 385;
	_ResStrIndex[kStr_SysTrapBase+339] = 548;
	_ResStrIndex[kStr_SysTrapBase+177] = 386;
	_ResStrIndex[kStr_SysTrapBase+178] = 387;
	_ResStrIndex[kStr_SysTrapBase+179] = 388;
	_ResStrIndex[kStr_CmdGremlinStep] = 98;
	_ResStrIndex[kStr_PalmOSErrorBase+timErrorClass+1] = 1806;
	_ResStrIndex[kStr_SysTrapBase+500] = 709;
	_ResStrIndex[kStr_SysTrapBase+501] = 710;
	_ResStrIndex[kStr_SysTrapBase+502] = 711;
	_ResStrIndex[kStr_SysTrapBase+340] = 549;
	_ResStrIndex[kStr_SysTrapBase+503] = 712;
	_ResStrIndex[kStr_SysTrapBase+341] = 550;
	_ResStrIndex[kStr_SysTrapBase+504] = 713;
	_ResStrIndex[kStr_SysTrapBase+342] = 551;
	_ResStrIndex[kStr_SysTrapBase+180] = 389;
	_ResStrIndex[kStr_SysTrapBase+505] = 714;
	_ResStrIndex[kStr_SysTrapBase+343] = 552;
	_ResStrIndex[kStr_SysTrapBase+181] = 390;
	_ResStrIndex[kStr_SysTrapBase+506] = 715;
	_ResStrIndex[kStr_SysTrapBase+344] = 553;
	_ResStrIndex[kStr_SysTrapBase+182] = 391;
	_ResStrIndex[kStr_SysTrapBase+507] = 716;
	_ResStrIndex[kStr_SysTrapBase+345] = 554;
	_ResStrIndex[kStr_SysTrapBase+183] = 392;
	_ResStrIndex[kStr_SysTrapBase+508] = 717;
	_ResStrIndex[kStr_SysTrapBase+346] = 555;
	_ResStrIndex[kStr_SysTrapBase+184] = 393;
	_ResStrIndex[kStr_SysTrapBase+509] = 718;
	_ResStrIndex[kStr_SysTrapBase+347] = 556;
	_ResStrIndex[kStr_SysTrapBase+185] = 394;
	_ResStrIndex[kStr_SysTrapBase+348] = 557;
	_ResStrIndex[kStr_SysTrapBase+186] = 395;
	_ResStrIndex[kStr_SysTrapBase+349] = 558;
	_ResStrIndex[kStr_SysTrapBase+187] = 396;
	_ResStrIndex[kStr_SysTrapBase+188] = 397;
	_ResStrIndex[kStr_SysTrapBase+189] = 398;
	_ResStrIndex[kStr_FileBusy] = 124;
	_ResStrIndex[kStr_ProfPartial] = 62;
	_ResStrIndex[kStr_CmdAbout] = 81;
	_ResStrIndex[kStr_SaveBeforeClosing] = 39;
	_ResStrIndex[kStr_SysTrapBase+510] = 719;
	_ResStrIndex[kStr_SysTrapBase+511] = 720;
	_ResStrIndex[kStr_SysTrapBase+512] = 721;
	_ResStrIndex[kStr_SysTrapBase+350] = 559;
	_ResStrIndex[kStr_SysTrapBase+513] = 722;
	_ResStrIndex[kStr_SysTrapBase+351] = 560;
	_ResStrIndex[kStr_SysTrapBase+514] = 723;
	_ResStrIndex[kStr_SysTrapBase+352] = 561;
	_ResStrIndex[kStr_SysTrapBase+190] = 399;
	_ResStrIndex[kStr_SysTrapBase+515] = 724;
	_ResStrIndex[kStr_SysTrapBase+353] = 562;
	_ResStrIndex[kStr_SysTrapBase+191] = 400;
	_ResStrIndex[kStr_SysTrapBase+516] = 725;
	_ResStrIndex[kStr_SysTrapBase+354] = 563;
	_ResStrIndex[kStr_SysTrapBase+192] = 401;
	_ResStrIndex[kStr_SysTrapBase+517] = 726;
	_ResStrIndex[kStr_SysTrapBase+355] = 564;
	_ResStrIndex[kStr_SysTrapBase+193] = 402;
	_ResStrIndex[kStr_SysTrapBase+518] = 727;
	_ResStrIndex[kStr_SysTrapBase+356] = 565;
	_ResStrIndex[kStr_SysTrapBase+194] = 403;
	_ResStrIndex[kStr_SysTrapBase+519] = 728;
	_ResStrIndex[kStr_SysTrapBase+357] = 566;
	_ResStrIndex[kStr_SysTrapBase+195] = 404;
	_ResStrIndex[kStr_SysTrapBase+358] = 567;
	_ResStrIndex[kStr_SysTrapBase+196] = 405;
	_ResStrIndex[kStr_SysTrapBase+359] = 568;
	_ResStrIndex[kStr_SysTrapBase+197] = 406;
	_ResStrIndex[kStr_SysTrapBase+198] = 407;
	_ResStrIndex[kStr_SysTrapBase+199] = 408;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+0] = 1344;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+1] = 1345;
	_ResStrIndex[kStr_TooManyFilesOpen] = 119;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+2] = 1346;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+3] = 1347;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+4] = 1348;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+5] = 1349;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+6] = 1350;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+7] = 1351;
	_ResStrIndex[kStr_PalmOSErrorBase+tsmErrorClass+8] = 1352;
	_ResStrIndex[kStr_SysTrapBase+520] = 729;
	_ResStrIndex[kStr_SysTrapBase+521] = 730;
	_ResStrIndex[kStr_SysTrapBase+522] = 731;
	_ResStrIndex[kStr_SysTrapBase+360] = 569;
	_ResStrIndex[kStr_SysTrapBase+523] = 732;
	_ResStrIndex[kStr_SysTrapBase+361] = 570;
	_ResStrIndex[kStr_SysTrapBase+524] = 733;
	_ResStrIndex[kStr_SysTrapBase+362] = 571;
	_ResStrIndex[kStr_SysTrapBase+525] = 734;
	_ResStrIndex[kStr_SysTrapBase+363] = 572;
	_ResStrIndex[kStr_SysTrapBase+526] = 735;
	_ResStrIndex[kStr_SysTrapBase+364] = 573;
	_ResStrIndex[kStr_SysTrapBase+527] = 736;
	_ResStrIndex[kStr_SysTrapBase+365] = 574;
	_ResStrIndex[kStr_BadChecksum] = 25;
	_ResStrIndex[kStr_SysTrapBase+528] = 737;
	_ResStrIndex[kStr_SysTrapBase+366] = 575;
	_ResStrIndex[kStr_SysTrapBase+529] = 738;
	_ResStrIndex[kStr_SysTrapBase+367] = 576;
	_ResStrIndex[kStr_SysTrapBase+368] = 577;
	_ResStrIndex[kStr_SysTrapBase+369] = 578;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+100] = 1689;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+101] = 1690;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+102] = 1691;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+103] = 1692;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+104] = 1693;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+105] = 1694;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+106] = 1695;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+107] = 1696;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+108] = 1697;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+109] = 1698;
	_ResStrIndex[kStr_OldFormat] = 135;
	_ResStrIndex[kStr_TimeoutError] = 113;
	_ResStrIndex[kStr_SysTrapBase+530] = 739;
	_ResStrIndex[kStr_SysTrapBase+531] = 740;
	_ResStrIndex[kStr_SysTrapBase+532] = 741;
	_ResStrIndex[kStr_SysTrapBase+370] = 579;
	_ResStrIndex[kStr_SysTrapBase+533] = 742;
	_ResStrIndex[kStr_SysTrapBase+371] = 580;
	_ResStrIndex[kStr_SysTrapBase+534] = 743;
	_ResStrIndex[kStr_SysTrapBase+372] = 581;
	_ResStrIndex[kStr_SysTrapBase+535] = 744;
	_ResStrIndex[kStr_SysTrapBase+373] = 582;
	_ResStrIndex[kStr_SysTrapBase+536] = 745;
	_ResStrIndex[kStr_SysTrapBase+374] = 583;
	_ResStrIndex[kStr_SysTrapBase+537] = 746;
	_ResStrIndex[kStr_SysTrapBase+375] = 584;
	_ResStrIndex[kStr_SysTrapBase+538] = 747;
	_ResStrIndex[kStr_SysTrapBase+376] = 585;
	_ResStrIndex[kStr_SysTrapBase+539] = 748;
	_ResStrIndex[kStr_SysTrapBase+377] = 586;
	_ResStrIndex[kStr_SysTrapBase+378] = 587;
	_ResStrIndex[kStr_SysTrapBase+379] = 588;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+110] = 1699;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+111] = 1700;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+112] = 1701;
	_ResStrIndex[kStr_NoPort] = 73;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+113] = 1702;
	_ResStrIndex[kStr_EmulatorOff] = 38;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+115] = 1703;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+116] = 1704;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+117] = 1705;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+118] = 1706;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+119] = 1707;
	_ResStrIndex[kStr_SysTrapBase+700] = 909;
	_ResStrIndex[kStr_SysTrapBase+701] = 910;
	_ResStrIndex[kStr_SysTrapBase+702] = 911;
	_ResStrIndex[kStr_SysTrapBase+540] = 749;
	_ResStrIndex[kStr_SysTrapBase+703] = 912;
	_ResStrIndex[kStr_SysTrapBase+541] = 750;
	_ResStrIndex[kStr_SysTrapBase+704] = 913;
	_ResStrIndex[kStr_SysTrapBase+542] = 751;
	_ResStrIndex[kStr_SysTrapBase+380] = 589;
	_ResStrIndex[kStr_SysTrapBase+705] = 914;
	_ResStrIndex[kStr_SysTrapBase+543] = 752;
	_ResStrIndex[kStr_SysTrapBase+381] = 590;
	_ResStrIndex[kStr_SysTrapBase+706] = 915;
	_ResStrIndex[kStr_SysTrapBase+544] = 753;
	_ResStrIndex[kStr_SysTrapBase+382] = 591;
	_ResStrIndex[kStr_SysTrapBase+707] = 916;
	_ResStrIndex[kStr_SysTrapBase+545] = 754;
	_ResStrIndex[kStr_SysTrapBase+383] = 592;
	_ResStrIndex[kStr_SysTrapBase+708] = 917;
	_ResStrIndex[kStr_SysTrapBase+546] = 755;
	_ResStrIndex[kStr_SysTrapBase+384] = 593;
	_ResStrIndex[kStr_SysTrapBase+709] = 918;
	_ResStrIndex[kStr_SysTrapBase+547] = 756;
	_ResStrIndex[kStr_SysTrapBase+385] = 594;
	_ResStrIndex[kStr_SysTrapBase+548] = 757;
	_ResStrIndex[kStr_SysTrapBase+386] = 595;
	_ResStrIndex[kStr_SysTrapBase+549] = 758;
	_ResStrIndex[kStr_SysTrapBase+387] = 596;
	_ResStrIndex[kStr_SysTrapBase+388] = 597;
	_ResStrIndex[kStr_SysTrapBase+389] = 598;
	_ResStrIndex[kStr_StackOverflowWarning] = 20;
	_ResStrIndex[kStr_UnlockedChunkAccess] = 7;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+120] = 1708;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+121] = 1709;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+122] = 1710;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+123] = 1711;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+124] = 1712;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+125] = 1713;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+126] = 1714;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+10] = 1578;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+127] = 1715;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+11] = 1579;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+10] = 1435;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+128] = 1716;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+11] = 1436;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+129] = 1717;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+12] = 1437;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+13] = 1438;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+14] = 1439;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+15] = 1440;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+16] = 1441;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+17] = 1442;
	_ResStrIndex[kStr_FileLocked] = 122;
	_ResStrIndex[kStr_SysTrapBase+710] = 919;
	_ResStrIndex[kStr_SysTrapBase+711] = 920;
	_ResStrIndex[kStr_SysTrapBase+712] = 921;
	_ResStrIndex[kStr_SysTrapBase+550] = 759;
	_ResStrIndex[kStr_SysTrapBase+713] = 922;
	_ResStrIndex[kStr_SysTrapBase+551] = 760;
	_ResStrIndex[kStr_SysTrapBase+714] = 923;
	_ResStrIndex[kStr_SysTrapBase+552] = 761;
	_ResStrIndex[kStr_SysTrapBase+390] = 599;
	_ResStrIndex[kStr_SysTrapBase+715] = 924;
	_ResStrIndex[kStr_SysTrapBase+553] = 762;
	_ResStrIndex[kStr_SysTrapBase+391] = 600;
	_ResStrIndex[kStr_SysTrapBase+716] = 925;
	_ResStrIndex[kStr_SysTrapBase+554] = 763;
	_ResStrIndex[kStr_SysTrapBase+392] = 601;
	_ResStrIndex[kStr_DeleteSomeFiles] = 139;
	_ResStrIndex[kStr_SysTrapBase+717] = 926;
	_ResStrIndex[kStr_SysTrapBase+555] = 764;
	_ResStrIndex[kStr_SysTrapBase+393] = 602;
	_ResStrIndex[kStr_SysTrapBase+718] = 927;
	_ResStrIndex[kStr_SysTrapBase+556] = 765;
	_ResStrIndex[kStr_SysTrapBase+394] = 603;
	_ResStrIndex[kStr_SysTrapBase+719] = 928;
	_ResStrIndex[kStr_SysTrapBase+557] = 766;
	_ResStrIndex[kStr_SysTrapBase+395] = 604;
	_ResStrIndex[kStr_SysTrapBase+558] = 767;
	_ResStrIndex[kStr_SysTrapBase+396] = 605;
	_ResStrIndex[kStr_SysTrapBase+559] = 768;
	_ResStrIndex[kStr_SysTrapBase+397] = 606;
	_ResStrIndex[kStr_SysTrapBase+398] = 607;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+1] = 1462;
	_ResStrIndex[kStr_SysTrapBase+399] = 608;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+130] = 1718;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+2] = 1463;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+131] = 1719;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+3] = 1464;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+4] = 1465;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+5] = 1466;
	_ResStrIndex[kStr_UserCancel] = 112;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+6] = 1467;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+10] = 1787;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+7] = 1468;
	_ResStrIndex[kStr_CmdDebugOptions] = 95;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+11] = 1788;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+8] = 1469;
	_ResStrIndex[kStr_DirectoryFull] = 114;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+12] = 1789;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+9] = 1470;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+13] = 1790;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+14] = 1791;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+16] = 1792;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+17] = 1793;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+19] = 1794;
	_ResStrIndex[kStr_InvalidFlags] = 76;
	_ResStrIndex[kStr_SysTrapBase+720] = 929;
	_ResStrIndex[kStr_SysTrapBase+721] = 930;
	_ResStrIndex[kStr_SysTrapBase+722] = 931;
	_ResStrIndex[kStr_SysTrapBase+560] = 769;
	_ResStrIndex[kStr_SysTrapBase+723] = 932;
	_ResStrIndex[kStr_SysTrapBase+561] = 770;
	_ResStrIndex[kStr_SysTrapBase+724] = 933;
	_ResStrIndex[kStr_SysTrapBase+562] = 771;
	_ResStrIndex[kStr_PalmOSErrorBase+flpErrorClass+1] = 1720;
	_ResStrIndex[kStr_SysTrapBase+725] = 934;
	_ResStrIndex[kStr_SysTrapBase+563] = 772;
	_ResStrIndex[kStr_SysTrapBase+726] = 935;
	_ResStrIndex[kStr_SysTrapBase+564] = 773;
	_ResStrIndex[kStr_SysTrapBase+727] = 936;
	_ResStrIndex[kStr_SysTrapBase+565] = 774;
	_ResStrIndex[kStr_SysTrapBase+728] = 937;
	_ResStrIndex[kStr_SysTrapBase+566] = 775;
	_ResStrIndex[kStr_SysTrapBase+729] = 938;
	_ResStrIndex[kStr_SysTrapBase+567] = 776;
	_ResStrIndex[kStr_SysTrapBase+568] = 777;
	_ResStrIndex[kStr_SysTrapBase+569] = 778;
	_ResStrIndex[kStr_CmdInstallMany] = 88;
	_ResStrIndex[kStr_PalmOSErrorBase+ftrErrorClass+1] = 1421;
	_ResStrIndex[kStr_PalmOSErrorBase+ftrErrorClass+2] = 1422;
	_ResStrIndex[kStr_PalmOSErrorBase+ftrErrorClass+3] = 1423;
	_ResStrIndex[kStr_PalmOSErrorBase+ftrErrorClass+4] = 1424;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+20] = 1795;
	_ResStrIndex[kStr_PalmOSErrorBase+ftrErrorClass+5] = 1425;
	_ResStrIndex[kStr_A5Access] = 14;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+21] = 1796;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+22] = 1797;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+23] = 1798;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+24] = 1799;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+25] = 1800;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+26] = 1801;
	_ResStrIndex[kStr_UnimplementedTrap] = 13;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+10] = 1757;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+11] = 1758;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+12] = 1759;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+13] = 1760;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+14] = 1761;
	_ResStrIndex[kStr_SysTrapBase+730] = 939;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+15] = 1762;
	_ResStrIndex[kStr_SysTrapBase+731] = 940;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+16] = 1763;
	_ResStrIndex[kStr_SysTrapBase+732] = 941;
	_ResStrIndex[kStr_SysTrapBase+570] = 779;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+17] = 1764;
	_ResStrIndex[kStr_SysTrapBase+733] = 942;
	_ResStrIndex[kStr_SysTrapBase+571] = 780;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+18] = 1765;
	_ResStrIndex[kStr_SysTrapBase+734] = 943;
	_ResStrIndex[kStr_SysTrapBase+572] = 781;
	_ResStrIndex[kStr_LowStackAccess] = 8;
	_ResStrIndex[kStr_SysTrapBase+735] = 944;
	_ResStrIndex[kStr_SysTrapBase+573] = 782;
	_ResStrIndex[kStr_SysTrapBase+736] = 945;
	_ResStrIndex[kStr_SysTrapBase+574] = 783;
	_ResStrIndex[kStr_SysTrapBase+737] = 946;
	_ResStrIndex[kStr_SysTrapBase+575] = 784;
	_ResStrIndex[kStr_SysTrapBase+738] = 947;
	_ResStrIndex[kStr_SysTrapBase+576] = 785;
	_ResStrIndex[kStr_SysTrapBase+739] = 948;
	_ResStrIndex[kStr_SysTrapBase+577] = 786;
	_ResStrIndex[kStr_SysTrapBase+578] = 787;
	_ResStrIndex[kStr_SysTrapBase+579] = 788;
	_ResStrIndex[kStr_GenericPalmError] = 128;
	_ResStrIndex[kStr_WebLibTrapBase+10] = 1330;
	_ResStrIndex[kStr_WebLibTrapBase+11] = 1331;
	_ResStrIndex[kStr_WebLibTrapBase+12] = 1332;
	_ResStrIndex[kStr_ProfTrapNameAddress] = 67;
	_ResStrIndex[kStr_WebLibTrapBase+13] = 1333;
	_ResStrIndex[kStr_WebLibTrapBase+14] = 1334;
	_ResStrIndex[kStr_SysTrapBase+740] = 949;
	_ResStrIndex[kStr_WebLibTrapBase+15] = 1335;
	_ResStrIndex[kStr_SysTrapBase+741] = 950;
	_ResStrIndex[kStr_WebLibTrapBase+16] = 1336;
	_ResStrIndex[kStr_SysTrapBase+742] = 951;
	_ResStrIndex[kStr_SysTrapBase+580] = 789;
	_ResStrIndex[kStr_WebLibTrapBase+17] = 1337;
	_ResStrIndex[kStr_SysTrapBase+743] = 952;
	_ResStrIndex[kStr_SysTrapBase+581] = 790;
	_ResStrIndex[kStr_WebLibTrapBase+18] = 1338;
	_ResStrIndex[kStr_SysTrapBase+744] = 953;
	_ResStrIndex[kStr_SysTrapBase+582] = 791;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+1] = 1404;
	_ResStrIndex[kStr_WebLibTrapBase+19] = 1339;
	_ResStrIndex[kStr_SysTrapBase+745] = 954;
	_ResStrIndex[kStr_SysTrapBase+583] = 792;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+2] = 1405;
	_ResStrIndex[kStr_SysTrapBase+746] = 955;
	_ResStrIndex[kStr_SysTrapBase+584] = 793;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+3] = 1406;
	_ResStrIndex[kStr_SysTrapBase+747] = 956;
	_ResStrIndex[kStr_SysTrapBase+585] = 794;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+4] = 1407;
	_ResStrIndex[kStr_SysTrapBase+748] = 957;
	_ResStrIndex[kStr_SysTrapBase+586] = 795;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+5] = 1408;
	_ResStrIndex[kStr_SysTrapBase+749] = 958;
	_ResStrIndex[kStr_SysTrapBase+587] = 796;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+6] = 1409;
	_ResStrIndex[kStr_SysTrapBase+588] = 797;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+7] = 1410;
	_ResStrIndex[kStr_SysTrapBase+589] = 798;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+8] = 1411;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+9] = 1412;
	_ResStrIndex[kStr_Cancel] = 55;
	_ResStrIndex[kStr_WebLibTrapBase+20] = 1340;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+1] = 1569;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+2] = 1570;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+1] = 1356;
	_ResStrIndex[kStr_SysTrapBase+750] = 959;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+3] = 1571;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+2] = 1357;
	_ResStrIndex[kStr_SysTrapBase+751] = 960;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+4] = 1572;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+3] = 1358;
	_ResStrIndex[kStr_SysTrapBase+752] = 961;
	_ResStrIndex[kStr_SysTrapBase+590] = 799;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+5] = 1573;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+4] = 1359;
	_ResStrIndex[kStr_SysTrapBase+753] = 962;
	_ResStrIndex[kStr_SysTrapBase+591] = 800;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+6] = 1574;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+5] = 1360;
	_ResStrIndex[kStr_SysTrapBase+754] = 963;
	_ResStrIndex[kStr_SysTrapBase+592] = 801;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+7] = 1575;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+6] = 1361;
	_ResStrIndex[kStr_SysTrapBase+755] = 964;
	_ResStrIndex[kStr_SysTrapBase+593] = 802;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+8] = 1576;
	_ResStrIndex[kStr_PalmOSErrorBase+cmpErrorClass+7] = 1362;
	_ResStrIndex[kStr_SysTrapBase+756] = 965;
	_ResStrIndex[kStr_SysTrapBase+594] = 803;
	_ResStrIndex[kStr_PalmOSErrorBase+memErrorClass+9] = 1577;
	_ResStrIndex[kStr_SysTrapBase+757] = 966;
	_ResStrIndex[kStr_SysTrapBase+595] = 804;
	_ResStrIndex[kStr_SysTrapBase+758] = 967;
	_ResStrIndex[kStr_SysTrapBase+596] = 805;
	_ResStrIndex[kStr_SysTrapBase+759] = 968;
	_ResStrIndex[kStr_SysTrapBase+597] = 806;
	_ResStrIndex[kStr_SysTrapBase+598] = 807;
	_ResStrIndex[kStr_SysTrapBase+599] = 808;
	_ResStrIndex[kStr_CmdGremlinStop] = 100;
	_ResStrIndex[kStr_OnlySameType] = 131;
	_ResStrIndex[kStr_UnlockTheFile] = 141;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+1] = 1451;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+2] = 1452;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+3] = 1453;
	_ResStrIndex[kStr_SysTrapBase+760] = 969;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+4] = 1454;
	_ResStrIndex[kStr_PalmOSErrorBase+fplErrorClass+1] = 1450;
	_ResStrIndex[kStr_SysTrapBase+761] = 970;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+5] = 1455;
	_ResStrIndex[kStr_SysTrapBase+762] = 971;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+6] = 1456;
	_ResStrIndex[kStr_SysTrapBase+763] = 972;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+7] = 1457;
	_ResStrIndex[kStr_SysTrapBase+764] = 973;
	_ResStrIndex[kStr_SizelessFormObject] = 23;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+8] = 1458;
	_ResStrIndex[kStr_SysTrapBase+765] = 974;
	_ResStrIndex[kStr_PalmOSErrorBase+grfErrorClass+9] = 1459;
	_ResStrIndex[kStr_SysTrapBase+766] = 975;
	_ResStrIndex[kStr_SysTrapBase+767] = 976;
	_ResStrIndex[kStr_SysTrapBase+768] = 977;
	_ResStrIndex[kStr_SysTrapBase+769] = 978;
	_ResStrIndex[kStr_PalmOSErrorBase+evtErrorClass+1] = 1775;
	_ResStrIndex[kStr_PalmOSErrorBase+evtErrorClass+2] = 1776;
	_ResStrIndex[kStr_PalmOSErrorBase+evtErrorClass+3] = 1777;
	_ResStrIndex[kStr_UnknownTrapNumber] = 71;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+10] = 1471;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+11] = 1472;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+12] = 1473;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+13] = 1474;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+14] = 1475;
	_ResStrIndex[kStr_BadROM] = 137;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+15] = 1476;
	_ResStrIndex[kStr_PalmOSErrorBase+htalErrorClass+16] = 1477;
	_ResStrIndex[kStr_UnsupportedROM] = 138;
	_ResStrIndex[kStr_GremlinNumber] = 28;
	_ResStrIndex[kStr_UnlockTheDisk] = 140;
	_ResStrIndex[kStr_SysTrapBase+770] = 979;
	_ResStrIndex[kStr_SysTrapBase+771] = 980;
	_ResStrIndex[kStr_SysTrapBase+772] = 981;
	_ResStrIndex[kStr_SysTrapBase+773] = 982;
	_ResStrIndex[kStr_SysTrapBase+774] = 983;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+1] = 1590;
	_ResStrIndex[kStr_SysTrapBase+775] = 984;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+2] = 1591;
	_ResStrIndex[kStr_SysTrapBase+776] = 985;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+3] = 1592;
	_ResStrIndex[kStr_SysTrapBase+777] = 986;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+4] = 1593;
	_ResStrIndex[kStr_SysTrapBase+778] = 987;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+5] = 1594;
	_ResStrIndex[kStr_SysTrapBase+779] = 988;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+6] = 1595;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+7] = 1596;
	_ResStrIndex[kStr_ProfDebugNameAddress] = 69;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+10] = 1816;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+8] = 1597;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+11] = 1817;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+9] = 1598;
	_ResStrIndex[kStr_GenericError] = 111;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+12] = 1818;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+13] = 1819;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+14] = 1820;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+15] = 1821;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+16] = 1822;
	_ResStrIndex[kStr_NULLMemAccess] = 15;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+17] = 1823;
	_ResStrIndex[kStr_ElapsedTime] = 31;
	_ResStrIndex[kStr_AppAndVers] = 26;
	_ResStrIndex[kStr_SysTrapBase+780] = 989;
	_ResStrIndex[kStr_SysTrapBase+781] = 990;
	_ResStrIndex[kStr_SysTrapBase+782] = 991;
	_ResStrIndex[kStr_SysTrapBase+783] = 992;
	_ResStrIndex[kStr_SysTrapBase+784] = 993;
	_ResStrIndex[kStr_SysTrapBase+785] = 994;
	_ResStrIndex[kStr_SysTrapBase+786] = 995;
	_ResStrIndex[kStr_SysTrapBase+787] = 996;
	_ResStrIndex[kStr_SysTrapBase+788] = 997;
	_ResStrIndex[kStr_SysTrapBase+789] = 998;
	_ResStrIndex[kStr_TransferAROM] = 143;
	_ResStrIndex[kStr_SysTrapBase+790] = 999;
	_ResStrIndex[kStr_SysTrapBase+791] = 1000;
	_ResStrIndex[kStr_SysTrapBase+792] = 1001;
	_ResStrIndex[kStr_SysTrapBase+793] = 1002;
	_ResStrIndex[kStr_SysTrapBase+794] = 1003;
	_ResStrIndex[kStr_SysTrapBase+795] = 1004;
	_ResStrIndex[kStr_UninitializedStackAccess] = 9;
	_ResStrIndex[kStr_SysTrapBase+796] = 1005;
	_ResStrIndex[kStr_SysTrapBase+797] = 1006;
	_ResStrIndex[kStr_ProfileResults] = 45;
	_ResStrIndex[kStr_SysTrapBase+798] = 1007;
	_ResStrIndex[kStr_SysTrapBase+799] = 1008;
	_ResStrIndex[kStr_Autorun] = 47;
	_ResStrIndex[kStr_CmdProfileDump] = 103;
	_ResStrIndex[kStr_UninitializedChunkAccess] = 11;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+10] = 1599;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+11] = 1600;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+12] = 1601;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+13] = 1602;
	_ResStrIndex[kStr_UnknownType] = 134;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+14] = 1603;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+15] = 1604;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+16] = 1605;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+17] = 1606;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+18] = 1607;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+19] = 1608;
	_ResStrIndex[kStr_UnhandledException] = 18;
	_ResStrIndex[kStr_OpenFiles] = 108;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+20] = 1609;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+21] = 1610;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+22] = 1611;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+23] = 1612;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+24] = 1613;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+25] = 1614;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+26] = 1615;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+27] = 1616;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+28] = 1617;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+29] = 1618;
	_ResStrIndex[kStr_CmdNew] = 82;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+30] = 1619;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+31] = 1620;
	_ResStrIndex[kStr_LoadPreferences] = 109;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+32] = 1621;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+33] = 1622;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+34] = 1623;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+1] = 1807;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+35] = 1624;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+2] = 1808;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+36] = 1625;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+3] = 1809;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+37] = 1626;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+4] = 1810;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+38] = 1627;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+5] = 1811;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+39] = 1628;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+6] = 1812;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+7] = 1813;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+8] = 1814;
	_ResStrIndex[kStr_PalmOSErrorBase+webErrorClass+9] = 1815;
	_ResStrIndex[kStr_CmdGremlinNew] = 97;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+40] = 1629;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+41] = 1630;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+42] = 1631;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+43] = 1632;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+44] = 1633;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+45] = 1634;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+46] = 1635;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+47] = 1636;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+48] = 1637;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+49] = 1638;
	_ResStrIndex[kStr_INetLibTrapBase+10] = 1120;
	_ResStrIndex[kStr_INetLibTrapBase+11] = 1121;
	_ResStrIndex[kStr_INetLibTrapBase+12] = 1122;
	_ResStrIndex[kStr_INetLibTrapBase+13] = 1123;
	_ResStrIndex[kStr_INetLibTrapBase+14] = 1124;
	_ResStrIndex[kStr_INetLibTrapBase+15] = 1125;
	_ResStrIndex[kStr_INetLibTrapBase+16] = 1126;
	_ResStrIndex[kStr_INetLibTrapBase+17] = 1127;
	_ResStrIndex[kStr_INetLibTrapBase+18] = 1128;
	_ResStrIndex[kStr_INetLibTrapBase+19] = 1129;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+50] = 1639;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+51] = 1640;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+52] = 1641;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+53] = 1642;
	_ResStrIndex[kStr_UnknownVersion] = 53;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+54] = 1643;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+55] = 1644;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+56] = 1645;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+57] = 1646;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+58] = 1647;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+59] = 1648;
	_ResStrIndex[kStr_HTALLibTrapBase+10] = 1104;
	_ResStrIndex[kStr_HTALLibTrapBase+11] = 1105;
	_ResStrIndex[kStr_HTALLibTrapBase+12] = 1106;
	_ResStrIndex[kStr_HTALLibTrapBase+13] = 1107;
	_ResStrIndex[kStr_HTALLibTrapBase+14] = 1108;
	_ResStrIndex[kStr_HTALLibTrapBase+15] = 1109;
	_ResStrIndex[kStr_HTALLibTrapBase+16] = 1110;
	_ResStrIndex[kStr_INetLibTrapBase+20] = 1130;
	_ResStrIndex[kStr_INetLibTrapBase+21] = 1131;
	_ResStrIndex[kStr_INetLibTrapBase+22] = 1132;
	_ResStrIndex[kStr_INetLibTrapBase+23] = 1133;
	_ResStrIndex[kStr_PressButton] = 107;
	_ResStrIndex[kStr_INetLibTrapBase+24] = 1134;
	_ResStrIndex[kStr_INetLibTrapBase+25] = 1135;
	_ResStrIndex[kStr_INetLibTrapBase+26] = 1136;
	_ResStrIndex[kStr_INetLibTrapBase+27] = 1137;
	_ResStrIndex[kStr_INetLibTrapBase+28] = 1138;
	_ResStrIndex[kStr_INetLibTrapBase+29] = 1139;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+60] = 1649;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+61] = 1650;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+62] = 1651;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+63] = 1652;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+64] = 1653;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+65] = 1654;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+66] = 1655;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+67] = 1656;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+68] = 1657;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+69] = 1658;
	_ResStrIndex[kStr_INetLibTrapBase+30] = 1140;
	_ResStrIndex[kStr_INetLibTrapBase+31] = 1141;
	_ResStrIndex[kStr_INetLibTrapBase+32] = 1142;
	_ResStrIndex[kStr_INetLibTrapBase+33] = 1143;
	_ResStrIndex[kStr_INetLibTrapBase+34] = 1144;
	_ResStrIndex[kStr_INetLibTrapBase+35] = 1145;
	_ResStrIndex[kStr_INetLibTrapBase+36] = 1146;
	_ResStrIndex[kStr_INetLibTrapBase+37] = 1147;
	_ResStrIndex[kStr_INetLibTrapBase+38] = 1148;
	_ResStrIndex[kStr_INetLibTrapBase+39] = 1149;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+70] = 1659;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+71] = 1660;
	_ResStrIndex[kStr_ExceptionBase + 10] = 155;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+72] = 1661;
	_ResStrIndex[kStr_ExceptionBase + 11] = 156;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+73] = 1662;
	_ResStrIndex[kStr_ExceptionBase + 12] = 157;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+74] = 1663;
	_ResStrIndex[kStr_ExceptionBase + 13] = 158;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+75] = 1664;
	_ResStrIndex[kStr_ExceptionBase + 14] = 159;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+76] = 1665;
	_ResStrIndex[kStr_ExceptionBase + 15] = 160;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+77] = 1666;
	_ResStrIndex[kStr_ExceptionBase + 16] = 161;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+78] = 1667;
	_ResStrIndex[kStr_ExceptionBase + 17] = 162;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+79] = 1668;
	_ResStrIndex[kStr_ExceptionBase + 18] = 163;
	_ResStrIndex[kStr_ExceptionBase + 19] = 164;
	_ResStrIndex[kStr_AppName] = 42;
	_ResStrIndex[kStr_LibTrapBase+0] = 1090;
	_ResStrIndex[kStr_LibTrapBase+1] = 1091;
	_ResStrIndex[kStr_StorageHeapAccess] = 12;
	_ResStrIndex[kStr_LibTrapBase+2] = 1092;
	_ResStrIndex[kStr_LibTrapBase+3] = 1093;
	_ResStrIndex[kStr_INetLibTrapBase+40] = 1150;
	_ResStrIndex[kStr_LibTrapBase+4] = 1094;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+80] = 1669;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+81] = 1670;
	_ResStrIndex[kStr_ExceptionBase + 20] = 165;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+82] = 1671;
	_ResStrIndex[kStr_ExceptionBase + 21] = 166;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+83] = 1672;
	_ResStrIndex[kStr_ExceptionBase + 22] = 167;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+84] = 1673;
	_ResStrIndex[kStr_ExceptionBase + 23] = 168;
	_ResStrIndex[kStr_OK] = 54;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+85] = 1674;
	_ResStrIndex[kStr_ExceptionBase + 24] = 169;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+86] = 1675;
	_ResStrIndex[kStr_ExceptionBase + 25] = 170;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+87] = 1676;
	_ResStrIndex[kStr_SysTrapBase+10] = 219;
	_ResStrIndex[kStr_ExceptionBase + 26] = 171;
	_ResStrIndex[kStr_No] = 57;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+88] = 1677;
	_ResStrIndex[kStr_SysTrapBase+11] = 220;
	_ResStrIndex[kStr_ExceptionBase + 27] = 172;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+89] = 1678;
	_ResStrIndex[kStr_SysTrapBase+12] = 221;
	_ResStrIndex[kStr_ExceptionBase + 28] = 173;
	_ResStrIndex[kStr_SysTrapBase+13] = 222;
	_ResStrIndex[kStr_ExceptionBase + 29] = 174;
	_ResStrIndex[kStr_SysTrapBase+14] = 223;
	_ResStrIndex[kStr_SysTrapBase+15] = 224;
	_ResStrIndex[kStr_SysTrapBase+16] = 225;
	_ResStrIndex[kStr_SysTrapBase+17] = 226;
	_ResStrIndex[kStr_SysTrapBase+18] = 227;
	_ResStrIndex[kStr_PalmOSErrorBase+mdmErrorClass+10] = 1589;
	_ResStrIndex[kStr_SysTrapBase+19] = 228;
	_ResStrIndex[kStr_CmdPreferences] = 93;
	_ResStrIndex[kStr_Untitled] = 43;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+90] = 1679;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+91] = 1680;
	_ResStrIndex[kStr_PalmOSErrorBase+txtErrorClass+1] = 1341;
	_ResStrIndex[kStr_ExceptionBase + 30] = 175;
	_ResStrIndex[kStr_OpenTheSerialPort] = 110;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+92] = 1681;
	_ResStrIndex[kStr_PalmOSErrorBase+txtErrorClass+2] = 1342;
	_ResStrIndex[kStr_ExceptionBase + 31] = 176;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+93] = 1682;
	_ResStrIndex[kStr_PalmOSErrorBase+txtErrorClass+3] = 1343;
	_ResStrIndex[kStr_ExceptionBase + 32] = 177;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+94] = 1683;
	_ResStrIndex[kStr_ExceptionBase + 33] = 178;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+95] = 1684;
	_ResStrIndex[kStr_ExceptionBase + 34] = 179;
	_ResStrIndex[kStr_DuplicateFileName] = 125;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+96] = 1685;
	_ResStrIndex[kStr_ExceptionBase + 35] = 180;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+97] = 1686;
	_ResStrIndex[kStr_SysTrapBase+20] = 229;
	_ResStrIndex[kStr_ExceptionBase + 36] = 181;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+98] = 1687;
	_ResStrIndex[kStr_SysTrapBase+21] = 230;
	_ResStrIndex[kStr_ExceptionBase + 37] = 182;
	_ResStrIndex[kStr_PalmOSErrorBase+netErrorClass+99] = 1688;
	_ResStrIndex[kStr_SysTrapBase+22] = 231;
	_ResStrIndex[kStr_ExceptionBase + 38] = 183;
	_ResStrIndex[kStr_SysTrapBase+23] = 232;
	_ResStrIndex[kStr_ExceptionBase + 39] = 184;
	_ResStrIndex[kStr_EnterPen] = 106;
	_ResStrIndex[kStr_SysTrapBase+24] = 233;
	_ResStrIndex[kStr_SysTrapBase+25] = 234;
	_ResStrIndex[kStr_SysTrapBase+26] = 235;
	_ResStrIndex[kStr_SysTrapBase+27] = 236;
	_ResStrIndex[kStr_SysTrapBase+28] = 237;
	_ResStrIndex[kStr_SysTrapBase+29] = 238;
	_ResStrIndex[kStr_ExceptionBase + 40] = 185;
	_ResStrIndex[kStr_ExceptionBase + 41] = 186;
	_ResStrIndex[kStr_ExceptionBase + 42] = 187;
	_ResStrIndex[kStr_ExceptionBase + 43] = 188;
	_ResStrIndex[kStr_ExceptionBase + 44] = 189;
	_ResStrIndex[kStr_ExceptionBase + 45] = 190;
	_ResStrIndex[kStr_SysTrapBase+30] = 239;
	_ResStrIndex[kStr_ExceptionBase + 46] = 191;
	_ResStrIndex[kStr_SysTrapBase+31] = 240;
	_ResStrIndex[kStr_ExceptionBase + 47] = 192;
	_ResStrIndex[kStr_DiskWriteProtected] = 121;
	_ResStrIndex[kStr_SysTrapBase+32] = 241;
	_ResStrIndex[kStr_ExceptionBase + 48] = 193;
	_ResStrIndex[kStr_SysTrapBase+33] = 242;
	_ResStrIndex[kStr_ExceptionBase + 49] = 194;
	_ResStrIndex[kStr_SysTrapBase+34] = 243;
	_ResStrIndex[kStr_SysTrapBase+35] = 244;
	_ResStrIndex[kStr_SysTrapBase+36] = 245;
	_ResStrIndex[kStr_SysTrapBase+37] = 246;
	_ResStrIndex[kStr_SysTrapBase+38] = 247;
	_ResStrIndex[kStr_SysTrapBase+39] = 248;
	_ResStrIndex[kStr_DefaultROMName] = 44;
	_ResStrIndex[kStr_INetLibTrapBase+1] = 1111;
	_ResStrIndex[kStr_INetLibTrapBase+2] = 1112;
	_ResStrIndex[kStr_INetLibTrapBase+3] = 1113;
	_ResStrIndex[kStr_INetLibTrapBase+4] = 1114;
	_ResStrIndex[kStr_INetLibTrapBase+5] = 1115;
	_ResStrIndex[kStr_InvalidLockCount] = 79;
	_ResStrIndex[kStr_INetLibTrapBase+6] = 1116;
	_ResStrIndex[kStr_ExceptionBase + 50] = 195;
	_ResStrIndex[kStr_INetLibTrapBase+7] = 1117;
	_ResStrIndex[kStr_ExceptionBase + 51] = 196;
	_ResStrIndex[kStr_INetLibTrapBase+8] = 1118;
	_ResStrIndex[kStr_ExceptionBase + 52] = 197;
	_ResStrIndex[kStr_INetLibTrapBase+9] = 1119;
	_ResStrIndex[kStr_ExceptionBase + 53] = 198;
	_ResStrIndex[kStr_ExceptionBase + 54] = 199;
	_ResStrIndex[kStr_ExceptionBase + 55] = 200;
	_ResStrIndex[kStr_SysTrapBase+40] = 249;
	_ResStrIndex[kStr_ExceptionBase + 56] = 201;
	_ResStrIndex[kStr_SysTrapBase+41] = 250;
	_ResStrIndex[kStr_ExceptionBase + 57] = 202;
	_ResStrIndex[kStr_DmErrDatabaseOpen] = 129;
	_ResStrIndex[kStr_SysTrapBase+42] = 251;
	_ResStrIndex[kStr_ExceptionBase + 58] = 203;
	_ResStrIndex[kStr_SysTrapBase+43] = 252;
	_ResStrIndex[kStr_ExceptionBase + 59] = 204;
	_ResStrIndex[kStr_SysTrapBase+44] = 253;
	_ResStrIndex[kStr_SysTrapBase+45] = 254;
	_ResStrIndex[kStr_SysTrapBase+46] = 255;
	_ResStrIndex[kStr_SysTrapBase+47] = 256;
	_ResStrIndex[kStr_SysTrapBase+48] = 257;
	_ResStrIndex[kStr_SysTrapBase+49] = 258;
	_ResStrIndex[kStr_SysTrapBase+200] = 409;
	_ResStrIndex[kStr_SysTrapBase+201] = 410;
	_ResStrIndex[kStr_SysTrapBase+202] = 411;
	_ResStrIndex[kStr_SysTrapBase+203] = 412;
	_ResStrIndex[kStr_SysTrapBase+204] = 413;
	_ResStrIndex[kStr_SysTrapBase+205] = 414;
	_ResStrIndex[kStr_SysTrapBase+206] = 415;
	_ResStrIndex[kStr_SysTrapBase+207] = 416;
	_ResStrIndex[kStr_SysTrapBase+208] = 417;
	_ResStrIndex[kStr_SysTrapBase+209] = 418;
	_ResStrIndex[kStr_ExceptionBase + 60] = 205;
	_ResStrIndex[kStr_XofYEvents] = 29;
	_ResStrIndex[kStr_ExceptionBase + 61] = 206;
	_ResStrIndex[kStr_ExceptionBase + 62] = 207;
	_ResStrIndex[kStr_ExceptionBase + 63] = 208;
	_ResStrIndex[kStr_SysTrapBase+50] = 259;
	_ResStrIndex[kStr_SysTrapBase+51] = 260;
	_ResStrIndex[kStr_SysTrapBase+52] = 261;
	_ResStrIndex[kStr_CmdSave] = 85;
	_ResStrIndex[kStr_SysTrapBase+53] = 262;
	_ResStrIndex[kStr_SysTrapBase+54] = 263;
	_ResStrIndex[kStr_SysTrapBase+55] = 264;
	_ResStrIndex[kStr_SysTrapBase+56] = 265;
	_ResStrIndex[kStr_SysTrapBase+57] = 266;
	_ResStrIndex[kStr_SysTrapBase+58] = 267;
	_ResStrIndex[kStr_SysTrapBase+59] = 268;
	_ResStrIndex[kStr_SysTrapBase+210] = 419;
	_ResStrIndex[kStr_SysTrapBase+211] = 420;
	_ResStrIndex[kStr_SysTrapBase+212] = 421;
	_ResStrIndex[kStr_SysTrapBase+213] = 422;
	_ResStrIndex[kStr_SysTrapBase+214] = 423;
	_ResStrIndex[kStr_LongMemSemaphore] = 22;
	_ResStrIndex[kStr_SysTrapBase+215] = 424;
	_ResStrIndex[kStr_SysTrapBase+216] = 425;
	_ResStrIndex[kStr_SysTrapBase+217] = 426;
	_ResStrIndex[kStr_SysTrapBase+218] = 427;
	_ResStrIndex[kStr_SysTrapBase+219] = 428;
	_ResStrIndex[kStr_SysTrapBase+60] = 269;
	_ResStrIndex[kStr_SysTrapBase+61] = 270;
	_ResStrIndex[kStr_SysTrapBase+62] = 271;
	_ResStrIndex[kStr_SysTrapBase+63] = 272;
	_ResStrIndex[kStr_SysTrapBase+64] = 273;
	_ResStrIndex[kStr_SysTrapBase+65] = 274;
	_ResStrIndex[kStr_SysTrapBase+66] = 275;
	_ResStrIndex[kStr_SysTrapBase+67] = 276;
	_ResStrIndex[kStr_SysTrapBase+68] = 277;
	_ResStrIndex[kStr_SysTrapBase+69] = 278;
	_ResStrIndex[kStr_SysTrapBase+220] = 429;
	_ResStrIndex[kStr_SysTrapBase+221] = 430;
	_ResStrIndex[kStr_SysTrapBase+222] = 431;
	_ResStrIndex[kStr_SysTrapBase+223] = 432;
	_ResStrIndex[kStr_SysTrapBase+224] = 433;
	_ResStrIndex[kStr_SysTrapBase+225] = 434;
	_ResStrIndex[kStr_SysTrapBase+226] = 435;
	_ResStrIndex[kStr_SysTrapBase+227] = 436;
	_ResStrIndex[kStr_SysTrapBase+228] = 437;
	_ResStrIndex[kStr_SysTrapBase+229] = 438;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+10] = 1741;
	_ResStrIndex[kStr_SysTrapBase+70] = 279;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+11] = 1742;
	_ResStrIndex[kStr_SysTrapBase+71] = 280;
	_ResStrIndex[kStr_AutorunAndQuit] = 48;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+12] = 1743;
	_ResStrIndex[kStr_SysTrapBase+72] = 281;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+13] = 1744;
	_ResStrIndex[kStr_SysTrapBase+73] = 282;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+14] = 1745;
	_ResStrIndex[kStr_SysTrapBase+74] = 283;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+15] = 1746;
	_ResStrIndex[kStr_SysTrapBase+75] = 284;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+16] = 1747;
	_ResStrIndex[kStr_SysTrapBase+76] = 285;
	_ResStrIndex[kStr_SysTrapBase+77] = 286;
	_ResStrIndex[kStr_SysTrapBase+78] = 287;
	_ResStrIndex[kStr_SysTrapBase+79] = 288;
	_ResStrIndex[kStr_GenericOperation] = 80;
	_ResStrIndex[kStr_ProfFunctions] = 63;
	_ResStrIndex[kStr_SysTrapBase+230] = 439;
	_ResStrIndex[kStr_SysTrapBase+231] = 440;
	_ResStrIndex[kStr_SysTrapBase+232] = 441;
	_ResStrIndex[kStr_SysTrapBase+233] = 442;
	_ResStrIndex[kStr_SysTrapBase+234] = 443;
	_ResStrIndex[kStr_SysTrapBase+235] = 444;
	_ResStrIndex[kStr_SysTrapBase+236] = 445;
	_ResStrIndex[kStr_SysTrapBase+237] = 446;
	_ResStrIndex[kStr_SysTrapBase+238] = 447;
	_ResStrIndex[kStr_SysTrapBase+239] = 448;
	_ResStrIndex[kStr_NPILibTrapBase+10] = 1265;
	_ResStrIndex[kStr_ProfInterruptX] = 66;
	_ResStrIndex[kStr_NPILibTrapBase+11] = 1266;
	_ResStrIndex[kStr_NPILibTrapBase+12] = 1267;
	_ResStrIndex[kStr_NPILibTrapBase+13] = 1268;
	_ResStrIndex[kStr_NPILibTrapBase+14] = 1269;
	_ResStrIndex[kStr_NPILibTrapBase+15] = 1270;
	_ResStrIndex[kStr_NPILibTrapBase+16] = 1271;
	_ResStrIndex[kStr_NPILibTrapBase+17] = 1272;
	_ResStrIndex[kStr_Reset] = 60;
	_ResStrIndex[kStr_NPILibTrapBase+18] = 1273;
	_ResStrIndex[kStr_SysTrapBase+80] = 289;
	_ResStrIndex[kStr_NPILibTrapBase+19] = 1274;
	_ResStrIndex[kStr_SysTrapBase+81] = 290;
	_ResStrIndex[kStr_SysTrapBase+82] = 291;
	_ResStrIndex[kStr_SysTrapBase+83] = 292;
	_ResStrIndex[kStr_DownloadAROM] = 144;
	_ResStrIndex[kStr_SysTrapBase+84] = 293;
	_ResStrIndex[kStr_SysTrapBase+85] = 294;
	_ResStrIndex[kStr_SysTrapBase+86] = 295;
	_ResStrIndex[kStr_SysTrapBase+87] = 296;
	_ResStrIndex[kStr_SysTrapBase+88] = 297;
	_ResStrIndex[kStr_SysTrapBase+89] = 298;
	_ResStrIndex[kStr_OnlyOnePSF] = 132;
	_ResStrIndex[kStr_SysTrapBase+400] = 609;
	_ResStrIndex[kStr_SysTrapBase+401] = 610;
	_ResStrIndex[kStr_SysTrapBase+402] = 611;
	_ResStrIndex[kStr_SysTrapBase+240] = 449;
	_ResStrIndex[kStr_OnlyOneROM] = 133;
	_ResStrIndex[kStr_SysTrapBase+403] = 612;
	_ResStrIndex[kStr_SysTrapBase+241] = 450;
	_ResStrIndex[kStr_SysTrapBase+404] = 613;
	_ResStrIndex[kStr_SysTrapBase+242] = 451;
	_ResStrIndex[kStr_SysTrapBase+405] = 614;
	_ResStrIndex[kStr_SysTrapBase+243] = 452;
	_ResStrIndex[kStr_SysTrapBase+406] = 615;
	_ResStrIndex[kStr_SysTrapBase+244] = 453;
	_ResStrIndex[kStr_SysTrapBase+407] = 616;
	_ResStrIndex[kStr_SysTrapBase+245] = 454;
	_ResStrIndex[kStr_ProfInterrupts] = 64;
	_ResStrIndex[kStr_SysTrapBase+408] = 617;
	_ResStrIndex[kStr_SysTrapBase+246] = 455;
	_ResStrIndex[kStr_SysTrapBase+409] = 618;
	_ResStrIndex[kStr_SysTrapBase+247] = 456;
	_ResStrIndex[kStr_SysTrapBase+248] = 457;
	_ResStrIndex[kStr_SysTrapBase+249] = 458;
	_ResStrIndex[kStr_UnknownFatalError] = 37;
	_ResStrIndex[kStr_SysTrapBase+90] = 299;
	_ResStrIndex[kStr_SysTrapBase+91] = 300;
	_ResStrIndex[kStr_SysTrapBase+92] = 301;
	_ResStrIndex[kStr_SysTrapBase+93] = 302;
	_ResStrIndex[kStr_SysTrapBase+94] = 303;
	_ResStrIndex[kStr_SysTrapBase+95] = 304;
	_ResStrIndex[kStr_SysTrapBase+96] = 305;
	_ResStrIndex[kStr_SysTrapBase+97] = 306;
	_ResStrIndex[kStr_SysTrapBase+98] = 307;
	_ResStrIndex[kStr_SysTrapBase+99] = 308;
	_ResStrIndex[kStr_SysTrapBase+410] = 619;
	_ResStrIndex[kStr_SysTrapBase+411] = 620;
	_ResStrIndex[kStr_SysTrapBase+412] = 621;
	_ResStrIndex[kStr_SysTrapBase+250] = 459;
	_ResStrIndex[kStr_SysTrapBase+413] = 622;
	_ResStrIndex[kStr_SysTrapBase+251] = 460;
	_ResStrIndex[kStr_SysTrapBase+414] = 623;
	_ResStrIndex[kStr_SysTrapBase+252] = 461;
	_ResStrIndex[kStr_SysTrapBase+415] = 624;
	_ResStrIndex[kStr_SysTrapBase+253] = 462;
	_ResStrIndex[kStr_SysTrapBase+416] = 625;
	_ResStrIndex[kStr_SysTrapBase+254] = 463;
	_ResStrIndex[kStr_SysTrapBase+417] = 626;
	_ResStrIndex[kStr_SysTrapBase+255] = 464;
	_ResStrIndex[kStr_SysTrapBase+418] = 627;
	_ResStrIndex[kStr_SysTrapBase+256] = 465;
	_ResStrIndex[kStr_SysTrapBase+419] = 628;
	_ResStrIndex[kStr_SysTrapBase+257] = 466;
	_ResStrIndex[kStr_PalmOSErrorBase+penErrorClass+1] = 1731;
	_ResStrIndex[kStr_SysTrapBase+258] = 467;
	_ResStrIndex[kStr_SysTrapBase+259] = 468;
	_ResStrIndex[kStr_SaveScreenAs] = 34;
	_ResStrIndex[kStr_Continue] = 58;
	_ResStrIndex[kStr_SysTrapBase+420] = 629;
	_ResStrIndex[kStr_SysTrapBase+421] = 630;
	_ResStrIndex[kStr_SysTrapBase+422] = 631;
	_ResStrIndex[kStr_SysTrapBase+260] = 469;
	_ResStrIndex[kStr_SysTrapBase+423] = 632;
	_ResStrIndex[kStr_SysTrapBase+261] = 470;
	_ResStrIndex[kStr_SysTrapBase+424] = 633;
	_ResStrIndex[kStr_SysTrapBase+262] = 471;
	_ResStrIndex[kStr_CmdBreakpoints] = 96;
	_ResStrIndex[kStr_SysTrapBase+425] = 634;
	_ResStrIndex[kStr_SysTrapBase+263] = 472;
	_ResStrIndex[kStr_EntireDevice] = 35;
	_ResStrIndex[kStr_SysTrapBase+426] = 635;
	_ResStrIndex[kStr_SysTrapBase+264] = 473;
	_ResStrIndex[kStr_SysTrapBase+427] = 636;
	_ResStrIndex[kStr_SysTrapBase+265] = 474;
	_ResStrIndex[kStr_SysTrapBase+428] = 637;
	_ResStrIndex[kStr_SysTrapBase+266] = 475;
	_ResStrIndex[kStr_SysTrapBase+429] = 638;
	_ResStrIndex[kStr_SysTrapBase+267] = 476;
	_ResStrIndex[kStr_SysTrapBase+268] = 477;
	_ResStrIndex[kStr_SysTrapBase+269] = 478;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+1] = 1748;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+2] = 1749;
	_ResStrIndex[kStr_WebLibTrapBase+1] = 1321;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+3] = 1750;
	_ResStrIndex[kStr_WebLibTrapBase+2] = 1322;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+4] = 1751;
	_ResStrIndex[kStr_WebLibTrapBase+3] = 1323;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+5] = 1752;
	_ResStrIndex[kStr_WebLibTrapBase+4] = 1324;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+6] = 1753;
	_ResStrIndex[kStr_WebLibTrapBase+5] = 1325;
	_ResStrIndex[kStr_CmdTransferROM] = 91;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+7] = 1754;
	_ResStrIndex[kStr_WebLibTrapBase+6] = 1326;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+8] = 1755;
	_ResStrIndex[kStr_WebLibTrapBase+7] = 1327;
	_ResStrIndex[kStr_PalmOSErrorBase+slkErrorClass+9] = 1756;
	_ResStrIndex[kStr_WebLibTrapBase+8] = 1328;
	_ResStrIndex[kStr_WebLibTrapBase+9] = 1329;
	_ResStrIndex[kStr_HTALLibTrapBase+1] = 1095;
	_ResStrIndex[kStr_HTALLibTrapBase+2] = 1096;
	_ResStrIndex[kStr_HTALLibTrapBase+3] = 1097;
	_ResStrIndex[kStr_HTALLibTrapBase+4] = 1098;
	_ResStrIndex[kStr_HTALLibTrapBase+5] = 1099;
	_ResStrIndex[kStr_HTALLibTrapBase+6] = 1100;
	_ResStrIndex[kStr_SysTrapBase+430] = 639;
	_ResStrIndex[kStr_HTALLibTrapBase+7] = 1101;
	_ResStrIndex[kStr_SysTrapBase+431] = 640;
	_ResStrIndex[kStr_HTALLibTrapBase+8] = 1102;
	_ResStrIndex[kStr_SysTrapBase+432] = 641;
	_ResStrIndex[kStr_SysTrapBase+270] = 479;
	_ResStrIndex[kStr_HTALLibTrapBase+9] = 1103;
	_ResStrIndex[kStr_SysTrapBase+433] = 642;
	_ResStrIndex[kStr_SysTrapBase+271] = 480;
	_ResStrIndex[kStr_SysTrapBase+434] = 643;
	_ResStrIndex[kStr_SysTrapBase+272] = 481;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+10] = 1487;
	_ResStrIndex[kStr_SysTrapBase+435] = 644;
	_ResStrIndex[kStr_SysTrapBase+273] = 482;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+11] = 1488;
	_ResStrIndex[kStr_SysTrapBase+436] = 645;
	_ResStrIndex[kStr_SysTrapBase+274] = 483;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+12] = 1489;
	_ResStrIndex[kStr_SysTrapBase+437] = 646;
	_ResStrIndex[kStr_SysTrapBase+275] = 484;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+13] = 1490;
	_ResStrIndex[kStr_SysTrapBase+438] = 647;
	_ResStrIndex[kStr_SysTrapBase+276] = 485;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+14] = 1491;
	_ResStrIndex[kStr_SysTrapBase+439] = 648;
	_ResStrIndex[kStr_SysTrapBase+277] = 486;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+15] = 1492;
	_ResStrIndex[kStr_SysTrapBase+278] = 487;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+16] = 1493;
	_ResStrIndex[kStr_SysTrapBase+279] = 488;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+17] = 1494;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+18] = 1495;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+19] = 1496;
	_ResStrIndex[kStr_CmdSaveScreen] = 86;
	_ResStrIndex[kStr_WrongROMForType] = 136;
	_ResStrIndex[kStr_ProfUnknownName] = 70;
	_ResStrIndex[kStr_SysTrapBase+600] = 809;
	_ResStrIndex[kStr_Browse] = 61;
	_ResStrIndex[kStr_SysTrapBase+601] = 810;
	_ResStrIndex[kStr_SysTrapBase+602] = 811;
	_ResStrIndex[kStr_SysTrapBase+440] = 649;
	_ResStrIndex[kStr_SysTrapBase+603] = 812;
	_ResStrIndex[kStr_SysTrapBase+441] = 650;
	_ResStrIndex[kStr_SysTrapBase+604] = 813;
	_ResStrIndex[kStr_SysTrapBase+442] = 651;
	_ResStrIndex[kStr_SysTrapBase+280] = 489;
	_ResStrIndex[kStr_SysTrapBase+605] = 814;
	_ResStrIndex[kStr_SysTrapBase+443] = 652;
	_ResStrIndex[kStr_SysTrapBase+281] = 490;
	_ResStrIndex[kStr_SysTrapBase+606] = 815;
	_ResStrIndex[kStr_SysTrapBase+444] = 653;
	_ResStrIndex[kStr_SysTrapBase+282] = 491;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+20] = 1497;
	_ResStrIndex[kStr_SysTrapBase+607] = 816;
	_ResStrIndex[kStr_SysTrapBase+445] = 654;
	_ResStrIndex[kStr_SysTrapBase+283] = 492;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+21] = 1498;
	_ResStrIndex[kStr_SysTrapBase+608] = 817;
	_ResStrIndex[kStr_SysTrapBase+446] = 655;
	_ResStrIndex[kStr_SysTrapBase+284] = 493;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+22] = 1499;
	_ResStrIndex[kStr_SysTrapBase+609] = 818;
	_ResStrIndex[kStr_SysTrapBase+447] = 656;
	_ResStrIndex[kStr_SysTrapBase+285] = 494;
	_ResStrIndex[kStr_SysTrapBase+448] = 657;
	_ResStrIndex[kStr_SysTrapBase+286] = 495;
	_ResStrIndex[kStr_SysTrapBase+449] = 658;
	_ResStrIndex[kStr_SysTrapBase+287] = 496;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+25] = 1500;
	_ResStrIndex[kStr_SysTrapBase+288] = 497;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+26] = 1501;
	_ResStrIndex[kStr_SysTrapBase+289] = 498;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+27] = 1502;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+28] = 1503;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+29] = 1504;
	_ResStrIndex[kStr_ReadFrom] = 49;
	_ResStrIndex[kStr_SysTrapBase+610] = 819;
	_ResStrIndex[kStr_SysTrapBase+611] = 820;
	_ResStrIndex[kStr_SysTrapBase+612] = 821;
	_ResStrIndex[kStr_SysTrapBase+450] = 659;
	_ResStrIndex[kStr_SysTrapBase+613] = 822;
	_ResStrIndex[kStr_SysTrapBase+451] = 660;
	_ResStrIndex[kStr_SysTrapBase+614] = 823;
	_ResStrIndex[kStr_SysTrapBase+452] = 661;
	_ResStrIndex[kStr_SysTrapBase+290] = 499;
	_ResStrIndex[kStr_SysTrapBase+615] = 824;
	_ResStrIndex[kStr_SysTrapBase+453] = 662;
	_ResStrIndex[kStr_SysTrapBase+291] = 500;
	_ResStrIndex[kStr_SysTrapBase+616] = 825;
	_ResStrIndex[kStr_SysTrapBase+454] = 663;
	_ResStrIndex[kStr_SysTrapBase+292] = 501;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+30] = 1505;
	_ResStrIndex[kStr_SysTrapBase+617] = 826;
	_ResStrIndex[kStr_SysTrapBase+455] = 664;
	_ResStrIndex[kStr_SysTrapBase+293] = 502;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+31] = 1506;
	_ResStrIndex[kStr_SysTrapBase+618] = 827;
	_ResStrIndex[kStr_SysTrapBase+456] = 665;
	_ResStrIndex[kStr_SysTrapBase+294] = 503;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+32] = 1507;
	_ResStrIndex[kStr_SysTrapBase+619] = 828;
	_ResStrIndex[kStr_SysTrapBase+457] = 666;
	_ResStrIndex[kStr_SysTrapBase+295] = 504;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+33] = 1508;
	_ResStrIndex[kStr_SysTrapBase+458] = 667;
	_ResStrIndex[kStr_SysTrapBase+296] = 505;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+34] = 1509;
	_ResStrIndex[kStr_SysTrapBase+459] = 668;
	_ResStrIndex[kStr_SysTrapBase+297] = 506;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+35] = 1510;
	_ResStrIndex[kStr_SysTrapBase+298] = 507;
	_ResStrIndex[kStr_SysTrapBase+299] = 508;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+37] = 1511;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+38] = 1512;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+39] = 1513;
	_ResStrIndex[kStr_BadFileName] = 118;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+1] = 1370;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+2] = 1371;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+3] = 1372;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+4] = 1373;
	_ResStrIndex[kStr_NetLibTrapBase+1] = 1189;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+5] = 1374;
	_ResStrIndex[kStr_NetLibTrapBase+2] = 1190;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+6] = 1375;
	_ResStrIndex[kStr_NetLibTrapBase+3] = 1191;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+7] = 1376;
	_ResStrIndex[kStr_NetLibTrapBase+4] = 1192;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+8] = 1377;
	_ResStrIndex[kStr_NetLibTrapBase+5] = 1193;
	_ResStrIndex[kStr_PalmOSErrorBase+dmErrorClass+9] = 1378;
	_ResStrIndex[kStr_NetLibTrapBase+6] = 1194;
	_ResStrIndex[kStr_NetLibTrapBase+7] = 1195;
	_ResStrIndex[kStr_NetLibTrapBase+8] = 1196;
	_ResStrIndex[kStr_NetLibTrapBase+9] = 1197;
	_ResStrIndex[kStr_SysTrapBase+620] = 829;
	_ResStrIndex[kStr_SysTrapBase+621] = 830;
	_ResStrIndex[kStr_SysTrapBase+622] = 831;
	_ResStrIndex[kStr_SysTrapBase+460] = 669;
	_ResStrIndex[kStr_SysTrapBase+623] = 832;
	_ResStrIndex[kStr_SysTrapBase+461] = 670;
	_ResStrIndex[kStr_SysTrapBase+624] = 833;
	_ResStrIndex[kStr_SysTrapBase+462] = 671;
	_ResStrIndex[kStr_SysTrapBase+625] = 834;
	_ResStrIndex[kStr_SysTrapBase+463] = 672;
	_ResStrIndex[kStr_SysTrapBase+626] = 835;
	_ResStrIndex[kStr_SysTrapBase+464] = 673;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+40] = 1514;
	_ResStrIndex[kStr_SysTrapBase+627] = 836;
	_ResStrIndex[kStr_SysTrapBase+465] = 674;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+41] = 1515;
	_ResStrIndex[kStr_SysTrapBase+628] = 837;
	_ResStrIndex[kStr_SysTrapBase+466] = 675;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+10] = 1729;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+42] = 1516;
	_ResStrIndex[kStr_SysTrapBase+629] = 838;
	_ResStrIndex[kStr_SysTrapBase+467] = 676;
	_ResStrIndex[kStr_PalmOSErrorBase+padErrorClass+11] = 1730;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+43] = 1517;
	_ResStrIndex[kStr_SysTrapBase+468] = 677;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+44] = 1518;
	_ResStrIndex[kStr_SysTrapBase+469] = 678;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+45] = 1519;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+46] = 1520;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+47] = 1521;
	_ResStrIndex[kStr_IOError] = 117;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+48] = 1522;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+49] = 1523;
	_ResStrIndex[kStr_CmdClose] = 84;
	_ResStrIndex[kStr_SysTrapBase+0] = 209;
	_ResStrIndex[kStr_SysTrapBase+1] = 210;
	_ResStrIndex[kStr_SysTrapBase+2] = 211;
	_ResStrIndex[kStr_SysTrapBase+3] = 212;
	_ResStrIndex[kStr_SysTrapBase+4] = 213;
	_ResStrIndex[kStr_SysTrapBase+5] = 214;
	_ResStrIndex[kStr_SysTrapBase+6] = 215;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+1] = 1732;
	_ResStrIndex[kStr_SysTrapBase+7] = 216;
	_ResStrIndex[kStr_CurrentAppLC] = 52;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+2] = 1733;
	_ResStrIndex[kStr_SysTrapBase+8] = 217;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+3] = 1734;
	_ResStrIndex[kStr_SysTrapBase+630] = 839;
	_ResStrIndex[kStr_SysTrapBase+9] = 218;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+4] = 1735;
	_ResStrIndex[kStr_SysTrapBase+631] = 840;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+5] = 1736;
	_ResStrIndex[kStr_SysTrapBase+632] = 841;
	_ResStrIndex[kStr_SysTrapBase+470] = 679;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+6] = 1737;
	_ResStrIndex[kStr_SysTrapBase+633] = 842;
	_ResStrIndex[kStr_SysTrapBase+471] = 680;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+7] = 1738;
	_ResStrIndex[kStr_SysTrapBase+634] = 843;
	_ResStrIndex[kStr_SysTrapBase+472] = 681;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+8] = 1739;
	_ResStrIndex[kStr_SysTrapBase+635] = 844;
	_ResStrIndex[kStr_SysTrapBase+473] = 682;
	_ResStrIndex[kStr_PalmOSErrorBase+secErrorClass+9] = 1740;
	_ResStrIndex[kStr_SysTrapBase+636] = 845;
	_ResStrIndex[kStr_SysTrapBase+474] = 683;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+50] = 1524;
	_ResStrIndex[kStr_SysTrapBase+637] = 846;
	_ResStrIndex[kStr_SysTrapBase+475] = 684;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+51] = 1525;
	_ResStrIndex[kStr_SysTrapBase+638] = 847;
	_ResStrIndex[kStr_SysTrapBase+476] = 685;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+52] = 1526;
	_ResStrIndex[kStr_SysTrapBase+639] = 848;
	_ResStrIndex[kStr_SysTrapBase+477] = 686;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+53] = 1527;
	_ResStrIndex[kStr_SysTrapBase+478] = 687;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+54] = 1528;
	_ResStrIndex[kStr_SysTrapBase+479] = 688;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+55] = 1529;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+56] = 1530;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+57] = 1531;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+58] = 1532;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+59] = 1533;
	_ResStrIndex[kStr_SysError] = 17;
	_ResStrIndex[kStr_Yes] = 56;
	_ResStrIndex[kStr_StackOverflowFatal] = 21;
	_ResStrIndex[kStr_SysTrapBase+800] = 1009;
	_ResStrIndex[kStr_SysTrapBase+801] = 1010;
	_ResStrIndex[kStr_SysTrapBase+802] = 1011;
	_ResStrIndex[kStr_SysTrapBase+640] = 849;
	_ResStrIndex[kStr_SysTrapBase+803] = 1012;
	_ResStrIndex[kStr_SysTrapBase+641] = 850;
	_ResStrIndex[kStr_CmdReset] = 90;
	_ResStrIndex[kStr_SysTrapBase+804] = 1013;
	_ResStrIndex[kStr_SysTrapBase+642] = 851;
	_ResStrIndex[kStr_SysTrapBase+480] = 689;
	_ResStrIndex[kStr_SysTrapBase+805] = 1014;
	_ResStrIndex[kStr_SysTrapBase+643] = 852;
	_ResStrIndex[kStr_SysTrapBase+481] = 690;
	_ResStrIndex[kStr_SysTrapBase+806] = 1015;
	_ResStrIndex[kStr_SysTrapBase+644] = 853;
	_ResStrIndex[kStr_SysTrapBase+482] = 691;
	_ResStrIndex[kStr_SysTrapBase+807] = 1016;
	_ResStrIndex[kStr_SysTrapBase+645] = 854;
	_ResStrIndex[kStr_SysTrapBase+483] = 692;
	_ResStrIndex[kStr_SysTrapBase+808] = 1017;
	_ResStrIndex[kStr_SysTrapBase+646] = 855;
	_ResStrIndex[kStr_SysTrapBase+484] = 693;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+1] = 1766;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+60] = 1534;
	_ResStrIndex[kStr_SysTrapBase+809] = 1018;
	_ResStrIndex[kStr_SysTrapBase+647] = 856;
	_ResStrIndex[kStr_SysTrapBase+485] = 694;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+2] = 1767;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+61] = 1535;
	_ResStrIndex[kStr_SysTrapBase+648] = 857;
	_ResStrIndex[kStr_SysTrapBase+486] = 695;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+3] = 1768;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+62] = 1536;
	_ResStrIndex[kStr_SysTrapBase+649] = 858;
	_ResStrIndex[kStr_SysTrapBase+487] = 696;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+4] = 1769;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+63] = 1537;
	_ResStrIndex[kStr_SysTrapBase+488] = 697;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+5] = 1770;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+64] = 1538;
	_ResStrIndex[kStr_SysTrapBase+489] = 698;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+6] = 1771;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+65] = 1539;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+7] = 1772;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+66] = 1540;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+8] = 1773;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+67] = 1541;
	_ResStrIndex[kStr_PalmOSErrorBase+sndErrorClass+9] = 1774;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+68] = 1542;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+69] = 1543;
	_ResStrIndex[kStr_CmdLoggingOptions] = 94;
	_ResStrIndex[kStr_SerialPortBusy] = 127;
	_ResStrIndex[kStr_SysTrapBase+810] = 1019;
	_ResStrIndex[kStr_SysTrapBase+811] = 1020;
	_ResStrIndex[kStr_SysTrapBase+812] = 1021;
	_ResStrIndex[kStr_SysTrapBase+650] = 859;
	_ResStrIndex[kStr_SysTrapBase+813] = 1022;
	_ResStrIndex[kStr_SysTrapBase+651] = 860;
	_ResStrIndex[kStr_SysTrapBase+814] = 1023;
	_ResStrIndex[kStr_SysTrapBase+652] = 861;
	_ResStrIndex[kStr_SysTrapBase+490] = 699;
	_ResStrIndex[kStr_SysTrapBase+815] = 1024;
	_ResStrIndex[kStr_SysTrapBase+653] = 862;
	_ResStrIndex[kStr_SysTrapBase+491] = 700;
	_ResStrIndex[kStr_SysTrapBase+816] = 1025;
	_ResStrIndex[kStr_SysTrapBase+654] = 863;
	_ResStrIndex[kStr_SysTrapBase+492] = 701;
	_ResStrIndex[kStr_SysTrapBase+817] = 1026;
	_ResStrIndex[kStr_SysTrapBase+655] = 864;
	_ResStrIndex[kStr_SysTrapBase+493] = 702;
	_ResStrIndex[kStr_SysTrapBase+818] = 1027;
	_ResStrIndex[kStr_SysTrapBase+656] = 865;
	_ResStrIndex[kStr_SysTrapBase+494] = 703;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+70] = 1544;
	_ResStrIndex[kStr_SysTrapBase+819] = 1028;
	_ResStrIndex[kStr_SysTrapBase+657] = 866;
	_ResStrIndex[kStr_SysTrapBase+495] = 704;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+71] = 1545;
	_ResStrIndex[kStr_SysTrapBase+658] = 867;
	_ResStrIndex[kStr_SysTrapBase+496] = 705;
	_ResStrIndex[kStr_ChunkNotInHeap] = 74;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+72] = 1546;
	_ResStrIndex[kStr_SysTrapBase+659] = 868;
	_ResStrIndex[kStr_SysTrapBase+497] = 706;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+73] = 1547;
	_ResStrIndex[kStr_SysTrapBase+498] = 707;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+74] = 1548;
	_ResStrIndex[kStr_SysTrapBase+499] = 708;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+75] = 1549;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+76] = 1550;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+77] = 1551;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+78] = 1552;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+79] = 1553;
	_ResStrIndex[kStr_XEvents] = 30;
	_ResStrIndex[kStr_CmdGremlinResume] = 99;
	_ResStrIndex[kStr_SysTrapBase+820] = 1029;
	_ResStrIndex[kStr_CorruptedHeap] = 19;
	_ResStrIndex[kStr_SysTrapBase+821] = 1030;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+1] = 1426;
	_ResStrIndex[kStr_SysTrapBase+822] = 1031;
	_ResStrIndex[kStr_SysTrapBase+660] = 869;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+2] = 1427;
	_ResStrIndex[kStr_SysTrapBase+823] = 1032;
	_ResStrIndex[kStr_SysTrapBase+661] = 870;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+3] = 1428;
	_ResStrIndex[kStr_SysTrapBase+824] = 1033;
	_ResStrIndex[kStr_SysTrapBase+662] = 871;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+4] = 1429;
	_ResStrIndex[kStr_SysTrapBase+825] = 1034;
	_ResStrIndex[kStr_SysTrapBase+663] = 872;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+5] = 1430;
	_ResStrIndex[kStr_SysTrapBase+826] = 1035;
	_ResStrIndex[kStr_SysTrapBase+664] = 873;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+6] = 1431;
	_ResStrIndex[kStr_SysTrapBase+827] = 1036;
	_ResStrIndex[kStr_SysTrapBase+665] = 874;
	_ResStrIndex[kStr_DiskLocked] = 123;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+7] = 1432;
	_ResStrIndex[kStr_SysTrapBase+828] = 1037;
	_ResStrIndex[kStr_SysTrapBase+666] = 875;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+80] = 1554;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+8] = 1433;
	_ResStrIndex[kStr_SerLibTrapBase+10] = 1306;
	_ResStrIndex[kStr_SysTrapBase+829] = 1038;
	_ResStrIndex[kStr_SysTrapBase+667] = 876;
	_ResStrIndex[kStr_OpErrorRecover] = 1;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+81] = 1555;
	_ResStrIndex[kStr_PalmOSErrorBase+fileErrorClass+9] = 1434;
	_ResStrIndex[kStr_SerLibTrapBase+11] = 1307;
	_ResStrIndex[kStr_SysTrapBase+668] = 877;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+82] = 1556;
	_ResStrIndex[kStr_SerLibTrapBase+12] = 1308;
	_ResStrIndex[kStr_SysTrapBase+669] = 878;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+83] = 1557;
	_ResStrIndex[kStr_SerLibTrapBase+13] = 1309;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+84] = 1558;
	_ResStrIndex[kStr_SerLibTrapBase+14] = 1310;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+85] = 1559;
	_ResStrIndex[kStr_SerLibTrapBase+15] = 1311;
	_ResStrIndex[kStr_ErrDisplayMessage] = 36;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+86] = 1560;
	_ResStrIndex[kStr_SerLibTrapBase+16] = 1312;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+87] = 1561;
	_ResStrIndex[kStr_SerLibTrapBase+17] = 1313;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+88] = 1562;
	_ResStrIndex[kStr_SerLibTrapBase+18] = 1314;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+89] = 1563;
	_ResStrIndex[kStr_SerLibTrapBase+19] = 1315;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+10] = 1413;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+11] = 1414;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+12] = 1415;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+13] = 1416;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+14] = 1417;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+15] = 1418;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+16] = 1419;
	_ResStrIndex[kStr_PalmOSErrorBase+exgErrorClass+17] = 1420;
	_ResStrIndex[kStr_SysTrapBase+830] = 1039;
	_ResStrIndex[kStr_SysTrapBase+831] = 1040;
	_ResStrIndex[kStr_SysTrapBase+832] = 1041;
	_ResStrIndex[kStr_SysTrapBase+670] = 879;
	_ResStrIndex[kStr_HOffsetNotBackPointing] = 78;
	_ResStrIndex[kStr_SysTrapBase+833] = 1042;
	_ResStrIndex[kStr_SysTrapBase+671] = 880;
	_ResStrIndex[kStr_SysTrapBase+834] = 1043;
	_ResStrIndex[kStr_SysTrapBase+672] = 881;
	_ResStrIndex[kStr_SysTrapBase+835] = 1044;
	_ResStrIndex[kStr_SysTrapBase+673] = 882;
	_ResStrIndex[kStr_SysTrapBase+836] = 1045;
	_ResStrIndex[kStr_SysTrapBase+674] = 883;
	_ResStrIndex[kStr_SysTrapBase+837] = 1046;
	_ResStrIndex[kStr_SysTrapBase+675] = 884;
	_ResStrIndex[kStr_SysTrapBase+838] = 1047;
	_ResStrIndex[kStr_SysTrapBase+676] = 885;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+90] = 1564;
	_ResStrIndex[kStr_SerLibTrapBase+20] = 1316;
	_ResStrIndex[kStr_IrLibTrapBase+1] = 1151;
	_ResStrIndex[kStr_SysTrapBase+839] = 1048;
	_ResStrIndex[kStr_SysTrapBase+677] = 886;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+91] = 1565;
	_ResStrIndex[kStr_SerLibTrapBase+21] = 1317;
	_ResStrIndex[kStr_IrLibTrapBase+2] = 1152;
	_ResStrIndex[kStr_SysTrapBase+678] = 887;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+92] = 1566;
	_ResStrIndex[kStr_SerLibTrapBase+22] = 1318;
	_ResStrIndex[kStr_IrLibTrapBase+3] = 1153;
	_ResStrIndex[kStr_SysTrapBase+679] = 888;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+93] = 1567;
	_ResStrIndex[kStr_SerLibTrapBase+23] = 1319;
	_ResStrIndex[kStr_IrLibTrapBase+4] = 1154;
	_ResStrIndex[kStr_PalmOSErrorBase+inetErrorClass+94] = 1568;
	_ResStrIndex[kStr_SerLibTrapBase+24] = 1320;
	_ResStrIndex[kStr_IrLibTrapBase+5] = 1155;
	_ResStrIndex[kStr_IrLibTrapBase+6] = 1156;
	_ResStrIndex[kStr_IrLibTrapBase+7] = 1157;
	_ResStrIndex[kStr_IrLibTrapBase+8] = 1158;
	_ResStrIndex[kStr_IrLibTrapBase+9] = 1159;
	_ResStrIndex[kStr_ProfOverflow] = 65;
	_ResStrIndex[kStr_MemFull] = 126;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+1] = 1778;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+2] = 1779;
	_ResStrIndex[kStr_SysTrapBase+840] = 1049;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+3] = 1780;
	_ResStrIndex[kStr_SysTrapBase+841] = 1050;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+4] = 1781;
	_ResStrIndex[kStr_SysTrapBase+842] = 1051;
	_ResStrIndex[kStr_SysTrapBase+680] = 889;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+5] = 1782;
	_ResStrIndex[kStr_SysTrapBase+843] = 1052;
	_ResStrIndex[kStr_SysTrapBase+681] = 890;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+6] = 1783;
	_ResStrIndex[kStr_SysTrapBase+844] = 1053;
	_ResStrIndex[kStr_SysTrapBase+682] = 891;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+7] = 1784;
	_ResStrIndex[kStr_SysTrapBase+845] = 1054;
	_ResStrIndex[kStr_SysTrapBase+683] = 892;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+8] = 1785;
	_ResStrIndex[kStr_SysTrapBase+846] = 1055;
	_ResStrIndex[kStr_SysTrapBase+684] = 893;
	_ResStrIndex[kStr_PalmOSErrorBase+sysErrorClass+9] = 1786;
	_ResStrIndex[kStr_SysTrapBase+847] = 1056;
	_ResStrIndex[kStr_SysTrapBase+685] = 894;
	_ResStrIndex[kStr_SysTrapBase+848] = 1057;
	_ResStrIndex[kStr_SysTrapBase+686] = 895;
	_ResStrIndex[kStr_SysTrapBase+849] = 1058;
	_ResStrIndex[kStr_SysTrapBase+687] = 896;
	_ResStrIndex[kStr_SysTrapBase+688] = 897;
	_ResStrIndex[kStr_SysTrapBase+689] = 898;
	_ResStrIndex[kStr_ExceptionBase + 0] = 145;
	_ResStrIndex[kStr_ExceptionBase + 1] = 146;
	_ResStrIndex[kStr_ExceptionBase + 2] = 147;
	_ResStrIndex[kStr_ExceptionBase + 3] = 148;
	_ResStrIndex[kStr_ExceptionBase + 4] = 149;
	_ResStrIndex[kStr_ExceptionBase + 5] = 150;
	_ResStrIndex[kStr_ExceptionBase + 6] = 151;
	_ResStrIndex[kStr_CmdInstall] = 87;
	_ResStrIndex[kStr_ExceptionBase + 7] = 152;
	_ResStrIndex[kStr_ExceptionBase + 8] = 153;
	_ResStrIndex[kStr_ExceptionBase + 9] = 154;
	_ResStrIndex[kStr_SysTrapBase+850] = 1059;
	_ResStrIndex[kStr_SysTrapBase+851] = 1060;
	_ResStrIndex[kStr_SysTrapBase+852] = 1061;
	_ResStrIndex[kStr_SysTrapBase+690] = 899;
	_ResStrIndex[kStr_SysTrapBase+853] = 1062;
	_ResStrIndex[kStr_SysTrapBase+691] = 900;
	_ResStrIndex[kStr_SysTrapBase+854] = 1063;
	_ResStrIndex[kStr_SysTrapBase+692] = 901;
	_ResStrIndex[kStr_LogFileSize] = 41;
	_ResStrIndex[kStr_SysTrapBase+855] = 1064;
	_ResStrIndex[kStr_SysTrapBase+693] = 902;
	_ResStrIndex[kStr_SysTrapBase+856] = 1065;
	_ResStrIndex[kStr_SysTrapBase+694] = 903;
	_ResStrIndex[kStr_SysTrapBase+857] = 1066;
	_ResStrIndex[kStr_SysTrapBase+695] = 904;
	_ResStrIndex[kStr_SysTrapBase+858] = 1067;
	_ResStrIndex[kStr_SysTrapBase+696] = 905;
	_ResStrIndex[kStr_SysTrapBase+859] = 1068;
	_ResStrIndex[kStr_SysTrapBase+697] = 906;
	_ResStrIndex[kStr_SysTrapBase+698] = 907;
	_ResStrIndex[kStr_SysTrapBase+699] = 908;
	_ResStrIndex[kStr_SysTrapBase+860] = 1069;
	_ResStrIndex[kStr_SysTrapBase+861] = 1070;
	_ResStrIndex[kStr_SysTrapBase+862] = 1071;
	_ResStrIndex[kStr_SysTrapBase+863] = 1072;
	_ResStrIndex[kStr_SysTrapBase+864] = 1073;
	_ResStrIndex[kStr_SysTrapBase+865] = 1074;
	_ResStrIndex[kStr_SysTrapBase+866] = 1075;
	_ResStrIndex[kStr_SysTrapBase+867] = 1076;
	_ResStrIndex[kStr_SysTrapBase+868] = 1077;
	_ResStrIndex[kStr_SysTrapBase+869] = 1078;
	_ResStrIndex[kStr_NPILibTrapBase+1] = 1256;
	_ResStrIndex[kStr_NPILibTrapBase+2] = 1257;
	_ResStrIndex[kStr_NPILibTrapBase+3] = 1258;
	_ResStrIndex[kStr_NPILibTrapBase+4] = 1259;
	_ResStrIndex[kStr_NPILibTrapBase+5] = 1260;
	_ResStrIndex[kStr_NPILibTrapBase+6] = 1261;
	_ResStrIndex[kStr_NPILibTrapBase+7] = 1262;
	_ResStrIndex[kStr_ScreenAccess] = 5;
	_ResStrIndex[kStr_NPILibTrapBase+8] = 1263;
	_ResStrIndex[kStr_NPILibTrapBase+9] = 1264;
	_ResStrIndex[kStr_XofYFiles] = 27;
	_ResStrIndex[kStr_SysTrapBase+870] = 1079;
	_ResStrIndex[kStr_SysTrapBase+871] = 1080;
}

char *_ResGetString(int idx)
{
	return _ResStrTable[ _ResStrIndex[idx] ];
}
